"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DeviceWorkstation subclass:#WinWorkstation
	instanceVariableNames:'blackpixel whitepixel
		listOfFonts rootWin rootDC
		buttonsPressed eventTrace
		eventBuffer
		usingSystemPalette
		resizeFrameWidth resizeFrameHeight'
	classVariableNames:'RawKeysymTranslation BeepFrequency BeepDuration'
	poolDictionaries:''
	category:'Interface-Graphics'
!

!WinWorkstation primitiveDefinitions!
%{

# undef INT
# define INT WIN_INT
# undef Array
# define Array WIN_Array
# undef Number
# define Number WIN_Number
# undef Method
# define Method WIN_Method
# undef Point
# define Point WIN_Point
# undef Rectangle
# define Rectangle WIN_Rectangle
# undef True
# define True WIN_True
# undef False
# define False WIN_False
# undef Block

# undef xxCONTEXT
# define xxCONTEXT        WIN_CONTEXT
# undef _xxCONTEXT
# define _xxCONTEXT       _WIN_CONTEXT



#include <stdio.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

#include <stdarg.h>

/* #include <h/windows.h> */

#  include <windef.h>
#  include <winbase.h>
#  include <wingdi.h>
#  include <winuser.h>


#   ifdef __DEF_Array
#    undef Array
#    define Array __DEF_Array
#   endif
#   ifdef __DEF_Number
#    undef Number
#    define Number __DEF_Number
#   endif
#   ifdef __DEF_Method
#    undef Method
#    define Method __DEF_Method
#   endif
#   ifdef __DEF_Point
#    undef Point
#    define Point __DEF_Point
#   endif
#   ifdef __DEF_Block
#    define Block __DEF_Block
#   endif

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))
#define _HDCVal(o)           (_GCDATA(o)->hDC)
#define _HPENVal(o)          (_GCDATA(o)->hPen)
#define _HBRUSHVal(o)        (_GCDATA(o)->hBrush)

#define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#define ISCONNECTED          (__INST(rootDC) != nil)

struct gcData {
    HDC         hDC;
    HPEN        hPen;
    HBRUSH      hBrush;
    COLORREF    fgColor;
    COLORREF    bgColor;
    int         brushType;
    int         lineWidth;
    int         lineStyle;
    int         joinStyle;
    int         capStyle;
    int         fontAscent;
};

/*
 * some synthetic values
 */
# define Button1MotionMask      1
# define Button2MotionMask      2
# define Button3MotionMask      4

# define Button1Mask            Button1MotionMask
# define Button2Mask            Button2MotionMask
# define Button3Mask            Button3MotionMask

# define ControlMask            8
# define ShiftMask              16
# define LeftAltMask            32
# define RightAltMask           64

# define TRANSLATED_KEY         256

int AltMask = RightAltMask;
int MetaMask = LeftAltMask;

# define WhitePixel     RGB(0xFF, 0xFF, 0xFF)
# define BlackPixel     RGB(0, 0, 0)

#ifdef DEBUG
# define DPRINTF(x)             printf x
# define DDPRINTF(x)            /* nothing */
# define EVENT_PRINTF(x)        printf x
# define EVENT_PRINTF1(x)       /* */
# define EVENT_PRINTF2(x)       printf x
#else
# define DPRINTF(x)             /* */
# define DDPRINTF(x)            /* */
# define EVENT_PRINTF(x)        /* */
# define EVENT_PRINTF1(x)       /* */
# define EVENT_PRINTF2(x)       /* */
#endif

# define BR_SOLID       0
# define BR_PATTERN     1

# define LINE_SOLID     0
# define LINE_DASH      1
# define LINE_DDASH     2

# define _C_ARROW       1
# define _C_CROSS       2
# define _C_IBEAM       3
# define _C_ICON        4
# define _C_NO          5
# define _C_SIZE        6
# define _C_SIZEALL     7
# define _C_SIZENESW    8
# define _C_SIZENS      9
# define _C_SIZENWSE    10
# define _C_UPARROW     11
# define _C_WAIT        12

static HCURSOR H_C_ARROW = (HCURSOR)0;
static HCURSOR H_C_CROSS = (HCURSOR)0;
static HCURSOR H_C_IBEAM = (HCURSOR)0;
static HCURSOR H_C_ICON = (HCURSOR)0;
static HCURSOR H_C_NO = (HCURSOR)0;
static HCURSOR H_C_SIZE = (HCURSOR)0;
static HCURSOR H_C_SIZEALL = (HCURSOR)0;
static HCURSOR H_C_SIZENESW = (HCURSOR)0;
static HCURSOR H_C_SIZENS = (HCURSOR)0;
static HCURSOR H_C_SIZENWSE = (HCURSOR)0;
static HCURSOR H_C_UPARROW = (HCURSOR)0;
static HCURSOR H_C_WAIT = (HCURSOR)0;

static int evRootX, evRootY;
static HWND buttonWindow = (HWND)0;

%}
! !

!WinWorkstation primitiveVariables!
%{

static HANDLE hInstance = (HANDLE)0, 
	  hPrevInstance = (HANDLE)0;
static int firstInstance = 1;
static char *app_name = "ST/X";
static int __debug__ = 0;

static int __inCreate = 0;
static int create_topView;
static int create_minWidth;
static int create_maxWidth;
static int create_minHeight;
static int create_maxHeight;


%}
! !

!WinWorkstation primitiveFunctions!

%{

struct queuedEvent {
	struct queuedEvent     *ev_next;
	HWND                    ev_hWnd;
	UINT                    ev_message;
	UINT                    ev_wParam;
	int                     ev_arg1;
	int                     ev_arg2;
	int                     ev_arg3;
	int                     ev_arg4;
	int                     filler;
};

#define ev_x    ev_arg1
#define ev_y    ev_arg2
#define ev_w    ev_arg3
#define ev_h    ev_arg4

#define ev_keyCode   ev_wParam
#define ev_scanCode  ev_arg3
#define ev_modifiers ev_arg4

#define EV_CHUNK_SZ     1024
#define EV_CHUNK_CNT    (1024/sizeof(struct queuedEvent))
struct queuedEvent *eventFreeList = (struct queuedEvent *)0;
struct queuedEvent *eventQueueHead = (struct queuedEvent *)0;
struct queuedEvent *eventQueueTail = (struct queuedEvent *)0;

static
enqEvent(hWnd, message, wParam, arg1, arg2, arg3, arg4)
    HWND hWnd;
    UINT message;
    UINT wParam;
{
    struct queuedEvent *ev;
    struct queuedEvent *bulk;
    int i;

    ev = eventFreeList;
    if (ev) {
	eventFreeList = ev->ev_next;
    } else {
	bulk = (struct queuedEvent *) malloc(EV_CHUNK_SZ);
	for (i=1; i<EV_CHUNK_CNT; i++) {
	    bulk[i-1].ev_next = &(bulk[i]);
	}
	bulk[EV_CHUNK_CNT-1].ev_next = (struct queuedEvent *)0;
	ev = bulk;
	eventFreeList = &(bulk[1]);
    }
    ev->ev_next = (struct queuedEvent *)0;
    ev->ev_hWnd = hWnd;
    ev->ev_message = message;
    ev->ev_wParam = wParam;
    ev->ev_arg1 = arg1;
    ev->ev_arg2 = arg2;
    ev->ev_arg3 = arg3;
    ev->ev_arg4 = arg4;
    
    if (eventQueueTail) {
	eventQueueTail->ev_next = ev;
    } else {
	eventQueueHead = ev;
    }
    eventQueueTail = ev;
}

static
struct queuedEvent *
deqEvent() {
    struct queuedEvent *ev;

    ev = eventQueueHead;
    if (ev) {
	eventQueueHead = ev->ev_next;
	if (! eventQueueHead) {
	    eventQueueTail = (struct queuedEvent *)0;
	}
    }
    return ev;
}

static
freeEvent(ev)
    struct queuedEvent *ev;
{
    ev->ev_next = eventFreeList;
    eventFreeList = ev;
}

static
getModifiers()
{
    int modifiers;

    modifiers = 0;
    if (GetKeyState(VK_SHIFT) & 0x8000)
	modifiers |= ShiftMask;
    if (GetKeyState(VK_CONTROL) & 0x8000)
	modifiers |= ControlMask;
    if (GetKeyState(VK_RMENU) & 0x8000)
	modifiers |= RightAltMask;
    if (GetKeyState(VK_LMENU) & 0x8000)
	modifiers |= LeftAltMask;
    if (GetKeyState(VK_LBUTTON) & 0x8000)
	modifiers |= Button1Mask;
    if (GetKeyState(VK_MBUTTON) & 0x8000)
	modifiers |= Button2Mask;
    if (GetKeyState(VK_RBUTTON) & 0x8000)
	modifiers |= Button3Mask;

    return modifiers;
}

static
getAllWinEvents()
{
    MSG msg;
    int more;

    if (PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE)) {
	more = 1;
	while (more) {
	    GetMessage(&msg, (HWND)0, 0, 0);

	    if ((msg.message == WM_KEYDOWN) || (msg.message == WM_KEYUP)
	     || (msg.message == WM_SYSKEYDOWN) || (msg.message == WM_SYSKEYUP)) {
		if (((msg.wParam >= '0') && (msg.wParam <= 'Z'))
		 || (msg.wParam == 0x20)
		 || (msg.wParam >= 0xB0)) {
		    /* 
		     * translate to a WM_CHAR message
		     */
		    if (TranslateMessage(&msg))
			continue;
		}
	    }

	    evRootX = msg.pt.x;
	    evRootY = msg.pt.y;
	    DispatchMessage(&msg);
	    more = PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE);
	}
    }
}

static
winEventProcessing(hWnd, message, wParam, lParam, pDefault)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
    int *pDefault;
{
    LPMINMAXINFO lpmmi;
    WINDOWPOS *posStruct;
    int modifiers;
    int x, y, w, h;

/*
    EVENT_PRINTF(("winEvent hWin=0x%x message=0x%x wP=0x%x lP=0x%x\n", 
			hWnd, message, wParam, lParam));
*/

    /*
     * messages which are handled right here 
     */
    if (__inCreate) {
	EVENT_PRINTF(("in create\n"));

	switch (message) {
	    case WM_GETMINMAXINFO:
		if (create_topView) {
		    lpmmi = (LPMINMAXINFO) lParam;

		    DPRINTF(("WM_GETMINMAXINFO handle=%x got min: %d/%d\n",
				hWnd,
				lpmmi->ptMinTrackSize.x,
				lpmmi->ptMinTrackSize.y));
                                 

		    lpmmi->ptMaxSize.x = create_maxWidth;
		    lpmmi->ptMaxSize.y = create_maxHeight;
		    lpmmi->ptMaxTrackSize.x = create_maxWidth;
		    lpmmi->ptMaxTrackSize.y = create_maxHeight;
		    lpmmi->ptMinTrackSize.x = create_minWidth;
		    lpmmi->ptMinTrackSize.y = create_minHeight;
		    DPRINTF(("WM_GETMINMAXINFO handle=%x return min: %d/%d max: %d/%d\n", 
				    hWnd,
				    create_minWidth, create_minHeight,
				    create_maxWidth, create_maxHeight));
		    *pDefault = 0;
		    return 0;
		}
		break;
	}
    }

    /*
     * messages which are enqueued to be handled by the view thread
     */

    switch (message) {
	case WM_SETCURSOR:
	    *pDefault = 1;
	    return 0;

	case WM_WINDOWPOSCHANGED:
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGED\n"));

	    posStruct = (WINDOWPOS *)lParam;
	    if (! posStruct) {
		DPRINTF(("oops - no posStruct passed\n"));
		break;
	    }

	    {
		RECT rct;

		GetClientRect(hWnd, &rct);
		enqEvent(hWnd, message, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);
	    }
#if 0
	    enqEvent(hWnd, message, wParam,
			   posStruct->x, posStruct->y, 
			   posStruct->cx, posStruct->cy);
#endif

	    *pDefault = 0;
	    return 0;

	case WM_ERASEBKGND:
	    EVENT_PRINTF(("WM_ERASEBKGND\n"));
	    goto paint;

	case WM_PAINT:
	    EVENT_PRINTF(("WM_PAINT\n"));
	paint:
	    {
		RECT upd;

		if (GetUpdateRect(hWnd, &upd, 0)) {
		    if ((upd.left == upd.right) && (upd.top == upd.bottom)) {
			DPRINTF(("WM_PAINT: null rectangle\n"));
			ValidateRect(hWnd, NULL);
			break;
		    }

		    x = upd.left;
		    y = upd.top;
		    w = upd.right - upd.left + 1;
		    h = upd.bottom - upd.top + 1;

		    ValidateRect(hWnd, NULL);

		    enqEvent(hWnd, message, wParam, x, y, w, h);

		    *pDefault = 0;
		    return 0;
		}
	    }

	    *pDefault = 0;
	    return 0;
	    break;

	case WM_SHOWWINDOW:
	    EVENT_PRINTF(("WM_SHOWWINDOW\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    *pDefault = 0;
	    return 0;

	case WM_DESTROY:
	    EVENT_PRINTF2(("WM_DESTROY\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEACTIVATE:
	    EVENT_PRINTF2(("WM_MOUSEACTIVATE h=%x\n", hWnd));
	    SetFocus(hWnd);
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    *pDefault = 0;
	    return MA_ACTIVATE;

	case WM_ACTIVATE:
	    EVENT_PRINTF2(("WM_ACTIVATE %s h=%x\n", 
			    LOWORD(wParam) ? "active" : "inactive",
			    hWnd));

	    switch (LOWORD(wParam)) {
		case WA_INACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE inactive h=%x\n", hWnd));
		    break;
		case WA_ACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE active h=%x\n", hWnd));
		    break;
		case WA_CLICKACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE clkactive h=%x\n", hWnd));
		    break;
		default:
		    EVENT_PRINTF2(("WM_ACTIVATE ? h=%x\n", hWnd));
		    break;
	    }
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    break;

	case WM_SYSCHAR:
	    EVENT_PRINTF2(("WM_SYSCHAR h=%x %x\n", hWnd, wParam));
	    goto commonChar;

	case WM_CHAR:
	    EVENT_PRINTF2(("WM_CHAR h=%x %x\n", hWnd, wParam));
	commonChar:
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }
	    enqEvent(hWnd, WM_KEYDOWN, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    enqEvent(hWnd, WM_KEYUP, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    *pDefault = 0;
	    return 0;
         
	case WM_SYSKEYUP:
	    EVENT_PRINTF2(("WM_SYSKEYUP %x\n, wParam"));
	    goto commonKey;

	case WM_SYSKEYDOWN:
	    EVENT_PRINTF2(("WM_SYSKEYDOWN %x\n, wParam"));
	    goto commonKey;

	case WM_KEYUP:
	    EVENT_PRINTF2(("WM_KEYUP h=%x %x\n", hWnd, wParam));
	    goto commonKey;

	case WM_KEYDOWN:
	    EVENT_PRINTF2(("WM_KEYDOWN h=%x %x\n", hWnd, wParam));
	commonKey:
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }

	    enqEvent(hWnd, message, wParam, x, y, lParam, modifiers);
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEMOVE:
	    EVENT_PRINTF2(("WM_MOUSEMOVE h=%x\n", hWnd));
	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);
		enqEvent(hWnd, message, wParam, x, y, 0, 0);
	    }
	    *pDefault = 0;
	    return 0;
            
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
	    SetCapture(hWnd);
	    goto commonButton;

	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
	    ReleaseCapture();
	    goto commonButton;

	case WM_LBUTTONDBLCLK:
	case WM_MBUTTONDBLCLK:
	case WM_RBUTTONDBLCLK:
	commonButton:
	    modifiers = getModifiers();
	    EVENT_PRINTF2(("WM_BUTTONUP/DOWN h=%x pos=%d/%d\n", 
			   hWnd, LOWORD(lParam), HIWORD(lParam)));
	    enqEvent(hWnd, message, wParam, LOWORD(lParam),
					    HIWORD(lParam),
					    wParam,
					    modifiers);
	    *pDefault = 0;
	    return 0;

	case WM_KILLFOCUS:
	    EVENT_PRINTF(("WM_KILLFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    break;

	case WM_SETFOCUS:
	    EVENT_PRINTF(("WM_SETFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    break;
    }

    switch (message) {
	case WM_GETTEXT:
	    EVENT_PRINTF(("WM_GETTEXT\n"));
	    break;

	case WM_GETTEXTLENGTH:
	    EVENT_PRINTF(("WM_GETTEXTLENGTH\n"));
	    break;

	case WM_NCCREATE:
	    EVENT_PRINTF(("WM_NCCREATE\n"));
	    break;

	case WM_GETMINMAXINFO:
	    EVENT_PRINTF(("WM_GETMINMAXINFO\n"));
	    break;

	case WM_NCHITTEST:
	    EVENT_PRINTF(("WM_NCHITTEST\n"));
	    break;

	case WM_NCMOUSEMOVE:
	    EVENT_PRINTF(("WM_NCMOUSEMOVE\n"));
	    break;

	case WM_PARENTNOTIFY:
	    EVENT_PRINTF2(("WM_PARENTNOTIFY h=%x hChild=%x %d\n", 
				hWnd, lParam, LOWORD(wParam)));
	    break;

	case WM_SETCURSOR:
	    EVENT_PRINTF(("WM_SETCURSOR\n"));
	    break;

	case WM_NCLBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCLBUTTONDOWN\n"));
	    break;

	case WM_SETTEXT:
	    EVENT_PRINTF(("WM_SETTEXT\n"));
	    break;

	case 0x88:
	    EVENT_PRINTF(("0x88 (undoc)\n"));
	    break;

	case 0x231:
	    EVENT_PRINTF(("0x231 (undoc)\n"));
	    break;

	case 0x232:
	    EVENT_PRINTF(("0x232 (undoc)\n"));
	    break;

	case WM_SIZE:
	    EVENT_PRINTF(("WM_SIZE\n"));
	    break;

	case WM_CREATE:
	    EVENT_PRINTF(("WM_CREATE\n"));
	    break;

	case WM_NCCALCSIZE:
	    EVENT_PRINTF(("WM_NCCALCSIZE\n"));
	    break;

	case WM_NCPAINT:
	    EVENT_PRINTF(("WM_NCPAINT\n"));
	    break;

	case WM_SYSCOMMAND:
	    EVENT_PRINTF2(("WM_SYSCOMMAND\n"));
	    break;

	case WM_INITMENU:
	    EVENT_PRINTF(("WM_INITMENU\n"));
	    break;

	case WM_INITMENUPOPUP:
	    EVENT_PRINTF(("WM_INITMENUPOPUP\n"));
	    break;

	case WM_ENTERIDLE:
	    EVENT_PRINTF(("WM_ENTERIDLE\n"));
	    break;

	case WM_ENTERMENULOOP:
	    EVENT_PRINTF(("WM_ENTERMENULOOP\n"));
	    break;

	case WM_EXITMENULOOP:
	    EVENT_PRINTF(("WM_EXITMENULOOP\n"));
	    break;

	case WM_MENUSELECT:
	    EVENT_PRINTF(("WM_MENUSELECT\n"));
	    break;

	case WM_QUIT:
	    EVENT_PRINTF(("WM_QUIT\n"));
	    break;

	case WM_CLOSE:
	    EVENT_PRINTF(("WM_CLOSE\n"));
	    break;

	case WM_NCDESTROY:
	    EVENT_PRINTF(("WM_NCDESTROY\n"));
	    break;

	case WM_QUERYNEWPALETTE:
	    EVENT_PRINTF(("WM_QUERYNEWPALETTE\n"));
	    break;

	case WM_PALETTECHANGED:
	    EVENT_PRINTF(("WM_PALETTECHANGED\n"));
	    break;

	case WM_NCACTIVATE:
	    EVENT_PRINTF(("WM_NCACTIVATE\n"));
	    break;

	case WM_ACTIVATEAPP:
	    EVENT_PRINTF1(("WM_ACTIVATEAPP %s\n", wParam ? "active" : "inactive"));
	    break;

	case WM_MOVE:
	    EVENT_PRINTF(("WM_MOVE\n"));
	    break;

	case WM_SYSDEADCHAR:
	    EVENT_PRINTF2(("WM_SYSDEADCHAR %x\n, wParam"));
	    break;

	case WM_DEADCHAR:
	    EVENT_PRINTF2(("WM_DEADCHAR %x\n, wParam"));
	    break;

	case WM_PAINTICON:
	    EVENT_PRINTF(("WM_PAINTICON\n"));
	    break;

	case WM_ICONERASEBKGND:
	    EVENT_PRINTF(("WM_ICONERASEBKGND\n"));
	    break;

	case WM_WINDOWPOSCHANGING:
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGING\n"));
	    break;

	case WM_QUERYOPEN:
	    EVENT_PRINTF(("WM_QUERYOPEN\n"));
	    break;

	case WM_QUERYENDSESSION:
	    EVENT_PRINTF(("WM_QUERYENDSESSION\n"));
	    break;

	default:
	    EVENT_PRINTF(("msg = %x\n", message));
	    break;
    }
    return 0;
}

LONG APIENTRY
MainWndProc(hWnd, message, wParam, lParam) 
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
{
    int wantDefault = 1;
    int retVal;

    DDPRINTF((">> MainWndProc\n"));

    retVal = winEventProcessing(hWnd, message, wParam, lParam, &wantDefault);
    if (wantDefault) {
	DDPRINTF(("DefWindowProc\n"));
	retVal = DefWindowProc(hWnd, message, wParam, lParam);
    }
    DDPRINTF(("<< MainWndProc (%d)\n", retVal));
    return retVal;
}

%}
! !


!WinWorkstation  class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    See more documentation in my superclass, DeviceWorkstation.

    [author:]
	Claus Gittinger
"
! !

!WinWorkstation  class methodsFor:'initialization'!

initialize
    |d|

    super initialize.

    BeepFrequency := 440.       "/ Hertz
    BeepDuration := 200.        "/ millis

    RawKeysymTranslation := d := Dictionary new.
    d at:'Right Alt'     put:#'Alt_R'.
    d at:'Left Alt'      put:#'Alt_L'.
    d at:'Right Shift'   put:#'Shift_R'.
    d at:'Left Shift'    put:#'Shift_L'.
    d at:'Right Control' put:#'Ctrl_R'.
    d at:'Left Control'  put:#'Ctrl_L'.
    d at:'Control'       put:#'Ctrl'.

    d at:'Backspace'     put:#'BackSpace'.
    d at:'Up'            put:#'CursorUp'.
    d at:'Down'          put:#'CursorDown'.
    d at:'Right'         put:#'CursorRight'.
    d at:'Left'          put:#'CursorLeft'.
    d at:'Page Up'       put:#'PreviousPage'.
    d at:'Page Down'     put:#'NextPage'.
    d at:'Prnt Scrn'     put:#'Print'.

    (self getSystemMetrics:#swapButton) ifTrue:[
	ButtonTranslation := #(2 2 1)
    ] ifFalse:[
	ButtonTranslation := #(1 2 2)
    ]
! !

!WinWorkstation  class methodsFor:'error handling'!

debug:aBoolean
%{  /* NOCONTEXT */

    __debug__ = (aBoolean == true) ? 1 : 0;
%}
! !

!WinWorkstation  class methodsFor:'queries'!

platformName
    "ST-80 compatibility.
     Return a string describing the display systems platform."

    ^ 'WIN32'  

    "Modified: 26.5.1996 / 15:32:46 / cg"
!

getSystemMetrics:aSymbol
%{
    int info = 0;
    int isBool = 0;
    int arg;

    if (aSymbol == @symbol(swapButton)) {
	arg = SM_SWAPBUTTON;
	isBool = 1;
    } else if (aSymbol == @symbol(mouseButtons)) {
	arg = SM_CMOUSEBUTTONS;
    } else if (aSymbol == @symbol(iconWidth)) {
	arg = SM_CXICON;
    } else if (aSymbol == @symbol(iconHeight)) {
	arg = SM_CYICON;
    } else if (aSymbol == @symbol(cursorWidth)) {
	arg = SM_CXCURSOR;
    } else if (aSymbol == @symbol(cursorHeight)) {
	arg = SM_CYCURSOR;
    } else if (aSymbol == @symbol(captionHeight)) {
	arg = SM_CYCAPTION;
    } else if (aSymbol == @symbol(resizeFrameWidth)) {
	arg = SM_CXFRAME;
    } else if (aSymbol == @symbol(resizeFrameHeight)) {
	arg = SM_CYFRAME;
    } else if (aSymbol == @symbol(borderFrameWidth)) {
	arg = SM_CXBORDER;
    } else if (aSymbol == @symbol(borderFrameHeight)) {
	arg = SM_CYBORDER;
    } else if (aSymbol == @symbol(fullScreenWindowWidth)) {
	arg = SM_CXFULLSCREEN;
    } else if (aSymbol == @symbol(fullScreenWindowHeight)) {
	arg = SM_CYFULLSCREEN;
    } else {
	RETURN (nil);
    }
    info = GetSystemMetrics(arg);
    if (isBool) {
	RETURN (info ? true : false);
    }
    RETURN (__MKSMALLINT(info));
%}
! !

!WinWorkstation methodsFor:'accessing & queries'!

anyButtonMotionMask
    "return the state-mask for any button in motion events' state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(Button1MotionMask | Button2MotionMask | Button3MotionMask)); 
%}.
    ^ nil
!

blackpixel
    "return the colornumber of black"

    ^ blackpixel
!

button1MotionMask
    "return the state-mask for button1 in motion events' state-field.
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button1MotionMask)); 
%}

    "
     Display button1MotionMask
    "
!

button2MotionMask
    "return the state-mask for button2 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button2MotionMask)); 
%}
!

button3MotionMask
    "return the state-mask for button3 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button3MotionMask)); 
%}
!

buttonMotionMask:aButton
    "return the state-mask for button1 in motion events state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    if (aButton == __MKSMALLINT(1)) {
	RETURN (__MKSMALLINT(Button1MotionMask));    
    }
    if (aButton == __MKSMALLINT(2)) {
	RETURN (__MKSMALLINT(Button2MotionMask));    
    }
    if (aButton == __MKSMALLINT(3)) {
	RETURN (__MKSMALLINT(Button3MotionMask));    
    }
%}.
    ^ nil
!

controlMask
    "return the state-mask for the CTRL modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ControlMask));
%}
!

defaultEventMask
    "return a mask to enable some events by default."

%{  /* NOCONTEXT */
#ifdef XXX
    RETURN (__MKSMALLINT(ExposureMask | StructureNotifyMask |
			 KeyPressMask | KeyReleaseMask |
			 EnterWindowMask | LeaveWindowMask |
			 ButtonPressMask | ButtonMotionMask | ButtonReleaseMask ));
#endif
%}.
    ^ 0
!

displayFileDescriptor
    "return the displays fileNumber - for select"

%{  /* NOCONTEXT */
    RETURN (nil);
%}
!

displayName
    "return the X-connections display name.
     This is (currently) nil for the default display, 
     something like foo:0 for any other remote display.
     Future versions may return non-nil strings for the default display as well."

    ^ 'local'
!

protocolVersion
    "return the X-servers protocol version - should normally not be of
     any interest"

    ^ '1'

    "
     Display protocolVersion
    "
!

serverVendor
    "return the X-server vendor string - this should normally not be of
     any interest, but can be for special cases
     (to avoid bugs in certain implementations)"

    ^ 'microsoft'

    "
     Display serverVendor
    "
!

shiftMask
    "return the state-mask for the SHIFT modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ShiftMask));
%}
!

translatePoint:aPoint from:windowId1 to:windowId2
    "given a point in window1, return the coordinate in window2.
     This expects a device coordinate (relative to the first views origin)
     in aPoint and returns a device coordinate relative to the 2nd views origin.
     - use to xlate points from a window to rootwindow"

    |x1 y1 x2 y2|

    x1 := x2 := aPoint x truncated.
    y1 := y2 := aPoint y truncated.
%{
    int xpos, ypos;
    HWND w1, w2;
    RECT srcRect, dstRect;

    if (__isExternalAddress(windowId1)
     && __isExternalAddress(windowId2)
     && __bothSmallInteger(x1, y1)) {
	w1 = _HWNDVal(windowId1);
	w2 = _HWNDVal(windowId2);

	GetWindowRect(w1, &srcRect);
	GetWindowRect(w2, &dstRect);

printf("srcRect: %d/%d -> %d/%d   dstRect: %d/%d -> %d/%d\n",
    srcRect.left, srcRect.top, srcRect.right, srcRect.bottom,
    dstRect.left, dstRect.top, dstRect.right, dstRect.bottom);

	xpos = srcRect.left - dstRect.left + __intVal(x1);
	ypos = srcRect.top - dstRect.top + __intVal(y1);

	x2 = __MKSMALLINT(xpos);
	y2 = __MKSMALLINT(ypos);
    }
%}.
'translated ' print. aPoint print. ' from ' print. windowId1 address print.
' -> ' print. (x2@y2) print. ' in ' print. windowId2 address printCR.
    ^ (x2 @ y2)
!

vendorRelease
    "return the X-servers vendor release - should normally not be of
     any interest, but can be for special cases.
     (to avoid bugs in certain implementations)"

    ^ 1

    "
     Display vendorRelease
    "
!

whitepixel
    "return the colornumber of white"

    ^ whitepixel
! !

!WinWorkstation methodsFor:'accessing display capabilities'!

iconSizes
    "Get the preferred/supported icon sizes."

    |d|

    d := IdentityDictionary new.
    d at:#minWidth put:32.
    d at:#maxWidth put:32.
    d at:#widthStep put:1.
    d at:#minHeight put:32.
    d at:#maxHeight put:32.
    d at:#heightStep put:1.

    ^ OrderedCollection with:d

    "
     Display iconSizes
    "
!

supportsIconViews
    "return true, if this device supports views as icons.
     Only Xservers (currently) support this."

    ^ true

    "
     Display supportsIconViews 
    "

    "Modified: 10.6.1996 / 20:11:48 / cg"
    "Created: 10.6.1996 / 21:08:18 / cg"
! !

!WinWorkstation methodsFor:'bitmap/window creation'!

createBitmapFromArray:anArray width:w height:h
    |bitmapId|

    bitmapId := self primCreateBitmapFromArray:anArray width:w height:h.
    bitmapId isNil ifTrue:[
	'WINWORKSTATION: cannot create bitmap' errorPrintCR.
    ].
    ^ bitmapId
!

createBitmapWidth:w height:h
    "allocate a bitmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */
%}.
    ^ nil
!

createPixmapWidth:w height:h depth:d
    "allocate a pixmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* NOCONTEXT */
%}.
    ^ nil
!

createWindowFor:aView left:xpos top:ypos width:wwidth height:wheight
    "will vanish - for compatibility with previous versions"

    ^ self 
	  createWindowFor:aView 
	  origin:(xpos @ ypos)
	  extent:(wwidth @ wheight)
	  minExtent:(aView minExtent)
	  maxExtent:(aView maxExtent)
	  borderWidth:(aView borderWidth)
	  subViewOf:(aView superView)
	  onTop:(aView isPopUpView)
	  inputOnly:(aView isInputOnly)
	  label:(aView label)
	  cursor:(aView cursor)
	  icon:(aView icon)
	  iconView:(aView iconView)

    "Modified: 1.6.1996 / 13:22:48 / cg"
!

createWindowFor:aView
		 origin:origin
		 extent:extent
		 minExtent:minExt 
		 maxExtent:maxExt
		 borderWidth:bWidth
		 subViewOf:wsuperView
		 onTop:wisPopUpView
		 inputOnly:winputOnly
		 label:wlabel
		 cursor:wcursor
		 icon:wicon
		 iconView:wiconView

    |xpos ypos wwidth wheight minWidth minHeight maxWidth maxHeight 
     bColorId wsuperViewId wcursorId wiconId windowId
     weventMask wiconViewId bitGravity viewGravity vBgColor
     vBgForm deepForm preferredVisual preferredDepth|

    displayId isNil ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    origin notNil ifTrue:[
	xpos := origin x.
	ypos := origin y.
    ] ifFalse:[
	xpos := ypos := 0.
    ].
    extent notNil ifTrue:[
	wwidth := extent x.
	wheight := extent y.
    ] ifFalse:[
	wwidth := wheight := 100.
    ].
    minExt notNil ifTrue:[
	minWidth := minExt x.
	minHeight := minExt y
    ].
    maxExt notNil ifTrue:[
	maxWidth := maxExt x.
	maxHeight := maxExt y
    ].

    wsuperView notNil ifTrue:[
	wsuperViewId := wsuperView id
    ].
    wcursor isNil ifTrue:[
	'XWORKSTATION: cursor nil - defaulted' errorPrintNL
    ] ifFalse:[
	wcursorId := wcursor id
    ].

    wicon notNil ifTrue:[
	wiconId := wicon id
    ].
    wiconView notNil ifTrue:[
	wiconViewId := wiconView id
    ].
    weventMask := aView eventMask.

%{  /* STACK:16000 */
    extern void *__getHInstance(), *__getHPrevInstance();

    WNDCLASS wc;
    long bg, bd, bw;
    int winStyle;
    int w, h, x, y;
    int ncW, ncH;
    int min_width, min_height;
    int max_width, max_height;
    HANDLE parentHandle;
    HANDLE newWinHandle;
    char *windowName = NULL;
    int isTopWindow = 0;

    bg = WhitePixel;
    bd = BlackPixel;

    if (firstInstance) {
	DPRINTF(("first create - registerClass\n"));

	hInstance = (HANDLE) __getHInstance();
	hPrevInstance = (HANDLE) __getHPrevInstance();

	wc.style = /* CS_HREDRAW | CS_VREDRAW | */ CS_OWNDC | CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC) MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);

	wc.hbrBackground = CreateSolidBrush (bg);

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = app_name;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}
	firstInstance = 0;
    }

    if (__bothSmallInteger(wwidth, wheight)) {
	w = __intVal(wwidth);
	h = __intVal(wheight);
    } else {
	w = h = 100;
    }

    if (__bothSmallInteger(xpos, ypos)) {
	x = __intVal(xpos);
	y = __intVal(ypos);
    } else {
	x = y = 0;
    }

    if (__bothSmallInteger(minWidth, minHeight)) {
	min_width = __intVal(minWidth);
	min_height = __intVal(minHeight);
    } else {
	min_width = min_height = 0;
    }

    if (__bothSmallInteger(maxWidth, maxHeight)) {
	max_width = __intVal(maxWidth);
	max_height = __intVal(maxHeight);
    } else {
	max_width = max_height = 10000;
    }

    winStyle = 0;

    if (__isSmallInteger(bWidth)) {
	bw = __intVal(bWidth);
	if (bw) {
	    winStyle |= WS_BORDER;
	    bw = 1;
	}
    } else {
	bw = 0;
    }

    if (__isExternalAddress(wsuperViewId)) {
	/* 
	 * a child window
	 */
	parentHandle = _HANDLEVal(wsuperViewId);
	winStyle |= WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	DPRINTF(("parent handle=%x\n", parentHandle));

	create_topView = 0;
	ncW = bw * 2;
	ncH = bw * 2;
    } else {
	/* 
	 * a top window
	 */
	parentHandle = NULL;
	isTopWindow = 1;
	DPRINTF(("topview\n"));

	create_topView = 1;
	create_minWidth = min_width;
	create_maxWidth = max_width;
	create_minHeight = min_height;
	create_maxHeight = max_height;

	winStyle |= WS_CLIPCHILDREN;
	if (wisPopUpView == true) {
	    winStyle |= WS_POPUP;
	    ncW = bw * 2;
	    ncH = bw * 2;
	} else {
	    winStyle |= WS_OVERLAPPEDWINDOW;
	    ncW = __intVal(__INST(resizeFrameWidth));
	    ncH = 32 + 4 + 4; /* __intVal(__INST(resizeFrameHeight)) */;
DPRINTF(("fW=%d fH=%d\n",
	    __intVal(__INST(resizeFrameWidth)),
	    __intVal(__INST(resizeFrameHeight)) ));
	}
    }

    DPRINTF(("create%s pos==%d/%d size=%d/%d bw=%d ...\n", 
		(wisPopUpView ? " popUp" : ""), x, y, w, h, bw));

    __inCreate = 1;
    newWinHandle = CreateWindow(app_name, 
				"",     /* window class name */
				winStyle,
				x, y,
				w + ncW, h + ncH,
				parentHandle,
				NULL, hInstance, NULL);
    __inCreate = 0;

    DPRINTF(("handle = %x\n", newWinHandle));

    if (! newWinHandle) {
	RETURN ( nil );
    }

    /*
     * define its icon and name
     * (only makes sense for topWindows)
     */
    if (isTopWindow) {
	if (__isString(wlabel) || __isSymbol(wlabel)) {
	    windowName = (char *) __stringVal(wlabel);
	    DPRINTF(("title = %s\n", windowName));
	    (void) SetWindowText(newWinHandle, windowName);
	}
    }

    windowId = __MKOBJ(newWinHandle);
    DPRINTF(("done - create\n"));
%}.
    self addKnownView:aView withId:windowId.
    ^ windowId
!

destroyGC:aGCId
%{
    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);

	if (gcData->hDC) {
	    DeleteDC(gcData->hDC);
	    gcData->hDC = (HDC)0;
	}
	if (gcData->hPen) {
	    DeleteObject(gcData->hPen);
	    gcData->hPen = (HPEN)0;
	}
	if (gcData->hBrush) {
	    DeleteObject(gcData->hBrush);
	    gcData->hBrush = (HPEN)0;
	}
	free(gcData);
    }
%}.
    ^ self
!

destroyPixmap:aDrawableId
    self primitiveFailed
!

destroyView:aView withId:aWindowId
%{
    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    DestroyWindow(win);
	}
    }
%}.
    self removeKnownView:aView
!

gcFor:aDrawableId

%{  /* NOCONTEXT */
    HDC dc;
    struct gcData *gcData;

    if (__isExternalAddress(aDrawableId)) {
	dc = GetDC(_HWNDVal(aDrawableId));
	if (! dc) {
	    RETURN (nil);
	}
	gcData = (struct gcData *)malloc(sizeof(struct gcData));
	if (! gcData) {
	    RETURN (nil);
	}
	gcData->hDC = dc;
	gcData->hPen = (HPEN)0;
	gcData->hBrush = (HBRUSH)0;
	gcData->fgColor = (COLORREF)0;
	gcData->bgColor = (COLORREF)0;
	gcData->brushType = BR_SOLID;
	gcData->lineWidth = 1;
	gcData->lineStyle = PS_SOLID;
	gcData->joinStyle = PS_JOIN_MITER;
	gcData->capStyle = PS_ENDCAP_FLAT;

	RETURN ( __MKOBJ(gcData) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

primCreateBitmapFromArray:anArray width:w height:h

%{  /* UNLIMITEDSTACK */

    HANDLE newBitmapHandle;
    unsigned char fastBits[10000];
    int b_width, b_height, bytesPerRowST, bytesPerRowWN, padding, nBytes;
    int row, col;
    unsigned char *cp, *bPits;
    unsigned char *b_bits, *allocatedBits;
    unsigned char *pBits;

    if (__bothSmallInteger(w, h) && _isNonNilObject(anArray)) {
	b_width = __intVal(w);
	b_height = __intVal(h);
	bytesPerRowST = (b_width + 7) / 8;
	bytesPerRowWN = (b_width + 15) / 16;
	padding = bytesPerRowWN - bytesPerRowST;
	nBytes = b_height * bytesPerRowWN;
	if (nBytes < sizeof(fastBits)) {
	    cp = b_bits = fastBits;
	    allocatedBits = 0;
	} else {
	    cp = b_bits = allocatedBits = (unsigned char *) malloc(nBytes);
	    if (! cp) goto fail;
	}

	if (__qClass(anArray) == @global(Array)) {
	    goto fail;
	} else {
	    if (__qClass(anArray) == @global(ByteArray)) {
		pBits = __ByteArrayInstPtr(anArray)->ba_element;
		for (row = b_height; row; row--) {
		    for (col = b_height*bytesPerRowST; col; col--) {
			*cp++ = *pBits++;
		    }
		    cp += padding;
		}
	    } else {
		goto fail;
	    }
	}
	newBitmapHandle = CreateBitmap(b_width, b_height,
				       1, 1,
				       b_bits
				      );

	DPRINTF(("bitmap handle = %x\n", newBitmapHandle));

fail: ;
	if (allocatedBits)
	    free(allocatedBits);
	RETURN ( newBitmapHandle ? __MKOBJ(newBitmapHandle) : nil );
    }
    RETURN ( nil );
%}
!

rootWindowId
    "return the id of the root window.
     This is the window you see as background, 
     however, it may or may not be the real physical root window,
     since some window managers install a virtual root window on top
     of the real one. If this is the case, that views id is returned here."

    ^ rootWin
! !

!WinWorkstation methodsFor:'color stuff'!

colorRed:redVal green:greenVal blue:blueVal
    "allocate a color with rgb values (0..100) - return the color index (i.e. colorID).
     This method is obsoleted by #colorScaledRed:scaledGreen:scaledBlue:"

    |r g b|

    r := self percentToDeviceColorColorValue:redVal.
    g := self percentToDeviceColorColorValue:greenVal.
    b := self percentToDeviceColorColorValue:blueVal.
    ^ self colorScaledRed:r scaledGreen:g scaledBlue:b
!

colorScaledRed:r scaledGreen:g scaledBlue:b
    "allocate a color with rgb values (0..16rFFFF) - return the color index 
     (i.e. colorID)"
%{
    int id, ir, ig, ib;

    if (__bothSmallInteger(r, g) 
     && __isSmallInteger(b)) {
	ir = __intVal(r) >> 8;
	ig = __intVal(g) >> 8;
	ib = __intVal(b) >> 8;

	id = RGB ( ir, ig, ib);
	DDPRINTF(("alloc color %d/%d/%d -> %x\n", ir, ig, ib, id));
	RETURN ( __MKSMALLINT(id) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

freeColor:colorIndex
    "free a display color when its no longer needed"

    ^ self
!

getRGBFrom:index into:aBlock
    "get rgb components (0..100) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |val|

    self getScaledRGBFrom:index into:[:r :g :b |
	val := aBlock 
		value:(r * 100.0 / 16rFFFF)
		value:(g * 100.0 / 16rFFFF)
		value:(b * 100.0 / 16rFFFF)
    ].
    ^ val
!

getScaledRGBFrom:index into:aBlock
    "get rgb components (0 .. 16rFFFF) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |r g b|
%{
    int id = __intVal(index);
    int iR, iG, iB;

    if (__INST(usingSystemPalette) == true) {
	r = g = b = __MKSMALLINT(0);
    } else {
	iR = id & 0xFF;
	iG = (id >> 8) & 0xFF;
	iB = (id >> 16) & 0xFF;
	iR = (iR << 8) | iR;
	iG = (iG << 8) | iG;
	iB = (iB << 8) | iB;

	r = __MKSMALLINT(iR);
	g = __MKSMALLINT(iG);
	b = __MKSMALLINT(iB);
    }
%}.
    ^ aBlock value:r value:g value:b
!

percentToDeviceColorColorValue:aPercentage
    "given a color-component value in percent (0..100), return the corresponding
     WIN-component value (0..16rFFFF) as an integer"

%{  /* NOCONTEXT */

    if (__isSmallInteger(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * __intVal(aPercentage) / 100) );
    }
    if (__isFloat(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * (int)(__floatVal(aPercentage)) / 100) );
    }
%}.
    ^ (16rFFFF * aPercentage / 100) rounded
! !

!WinWorkstation methodsFor:'cursor stuff'!

createCursorShape:aShape
    "create a cursor given a shape-symbol"

    |number id|

    number := self shapeNumberFromSymbol:aShape.
%{
    HCURSOR newCursor;
    LPCTSTR cId;

    if (__isSmallInteger(number)) {
	cId = (LPCTSTR)(__intVal(number));
	newCursor = LoadCursor(NULL, cId);
	if (newCursor) {
	    if (cId == IDC_ARROW)
		H_C_ARROW = newCursor;
	    else if (cId == IDC_CROSS)
		H_C_CROSS = newCursor;
	    else if (cId == IDC_IBEAM)
		H_C_IBEAM = newCursor;
	    else if (cId == IDC_ICON)
		H_C_ICON = newCursor;
	    else if (cId == IDC_NO)
		H_C_NO = newCursor;
	    else if (cId == IDC_SIZE)
		H_C_SIZE = newCursor;
	    else if (cId == IDC_SIZEALL)
		H_C_SIZEALL = newCursor;
	    else if (cId == IDC_SIZENESW)
		H_C_SIZENESW = newCursor;
	    else if (cId == IDC_SIZENS)
		H_C_SIZENS = newCursor;
	    else if (cId == IDC_SIZENWSE)
		H_C_SIZENWSE = newCursor;
	    else if (cId == IDC_UPARROW)
		H_C_UPARROW = newCursor;
	    else if (cId == IDC_WAIT)
		H_C_WAIT = newCursor;
        
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

createCursorSourceForm:sourceBytes maskForm:maskBytes hotX:hx hotY:hy width:w height:h
    "create a cursor given 2 bitmaps (source, mask) and a hotspot"

    |id|

%{
    HCURSOR newCursor;

    if (__isByteArray(sourceBytes)
     && __isByteArray(maskBytes)
     && __bothSmallInteger(hx, hy)
     && __bothSmallInteger(w, h)) {

	newCursor = CreateCursor(hInstance,
				 __intVal(hx), __intVal(hy),
				 __intVal(w), __intVal(h),
				__ByteArrayInstPtr(maskBytes)->ba_element,
				__ByteArrayInstPtr(sourceBytes)->ba_element);
	if (newCursor) {
	    id = __MKOBJ(newCursor);
	}
    }
%}.
    ^ id
!

destroyCursor:aCursorId

%{  /* NOCONTEXT */

    if (ISCONNECTED) {
	if (__isExternalAddress(aCursorId)) {
	    HCURSOR curs = _HCURSORVal(aCursorId);

	    if (curs) {
		if ((curs != H_C_ARROW)
		 && (curs != H_C_CROSS)
		 && (curs != H_C_IBEAM)
		 && (curs != H_C_ICON)
		 && (curs != H_C_NO)
		 && (curs != H_C_SIZE)
		 && (curs != H_C_SIZEALL)
		 && (curs != H_C_SIZENESW)
		 && (curs != H_C_SIZENS)
		 && (curs != H_C_SIZENWSE)
		 && (curs != H_C_UPARROW)
		 && (curs != H_C_WAIT)) {
		    DestroyCursor(curs);
		}
	    }
	    RETURN ( self );
	}
    }
%}.
    self primitiveFailed
!

needDeviceFormsForCursor
    ^ false
!

shapeNumberFromSymbol:shape
    "given a shape-symbol, return the corresponding cursor-number,
     or nil if no such standard cursor exists."

    "this is pure Win-knowlegde - but you may easily add more"

%{  /* NOCONTEXT */
    if (shape == @symbol(upLeftArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_ARROW));
    }
    if (shape == @symbol(upDownArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZENS));
    }
    if (shape == @symbol(leftRightArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZEWE));
    }
    if (shape == @symbol(text)) {
	RETURN ( __MKSMALLINT( (INT)IDC_IBEAM));
    }
    if (shape == @symbol(wait)) {
	RETURN ( __MKSMALLINT( (INT)IDC_WAIT));
    }
    if (shape == @symbol(crossHair)) {
	RETURN ( __MKSMALLINT( (INT)IDC_CROSS));
    }
    if (shape == @symbol(fourWay)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZE));
    }
%}.
"/    ('WINWORKSTATION: invalid cursorShape:' , shape printString) infoPrintNL.
    ^  nil
! !

!WinWorkstation methodsFor:'drawing'!

copyFromId:sourceId x:srcX y:srcY gc:srcGCId to:destId x:dstX y:dstY gc:dstGCId
		width:w height:h 
    "do a bit-blt; copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

%{  /* NOCONTEXT */

    HDC srcDC, dstDC;

    if (__isExternalAddress(srcGCId)
     && __isExternalAddress(dstGCId)
     && __bothSmallInteger(w, h)
     && __bothSmallInteger(srcX, srcY)
     && __bothSmallInteger(dstX, dstY)) {
        
	srcDC = _HDCVal(srcGCId);
	dstDC = _HDCVal(dstGCId);
	BitBlt(dstDC, 
	       __intVal(dstX), __intVal(dstY),
	       __intVal(w), __intVal(h),
	       srcDC,
	       __intVal(srcX), __intVal(srcY),
	       SRCCOPY);
	RETURN ( self );
    }
%}.
    "badGC, bad sourceDrawableId or destDrawableID
     or any non integer coordinate"

    self primitiveFailed
!

copyPlaneFromId:sourceId x:srcX y:srcY gc:srcDCId to:destId x:dstX y:dstY gc:dstDCId
		width:w height:h 
    "do a bit-blt, but only copy the low-bit plane; 
     copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

    ^ self
	copyFromId:sourceId 
		 x:srcX y:srcY gc:srcDCId 
		to:destId x:dstX y:dstY gc:dstDCId
	     width:w height:h 
!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:aDrawableId with:aGCId
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:aDrawableId with:aGCId
    "draw a line. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HBRUSH hBrush;
	HPEN hPen;

	DPRINTF(("displayLine: %d/%d -> %d/%d\n", __intVal(x0), __intVal(y0),
						  __intVal(x1), __intVal(y1)));

	hDC = _HDCVal(aGCId);
	hPen = gcData->hPen;

	if (! hPen) {
	    hPen = gcData->hPen = CreatePen(gcData->lineStyle,
					    gcData->lineWidth,
					    gcData->fgColor);
	}

	if (! hPen) {
	    DPRINTF(("displayLine: no pen\n"));
	} else {
	    MoveToEx(hDC, __intVal(x0), __intVal(y0), NULL);
	    LineTo(hDC, __intVal(x1), __intVal(y1));
	}

	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayPointX:x y:y in:aDrawableId with:aGCId
    "draw a point. If x/y are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)) {
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or x/y not integer"
    self primitiveFailed
!

displayPolygon:aPolygon in:aDrawableId with:aGCId
    "draw a polygon, the argument aPolygon is a Collection of individual points, which
     define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints newPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, x, y;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    x = _point_X(point);
	    y = _point_Y(point);
	    if (! __bothSmallInteger(x, y))
		goto fail;
	}
	RETURN ( self );
    }
fail: ;
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "draw a rectangle. If the coordinates are not integers, an error is triggered." 

%{  /* NOCONTEXT */
    int w, h;
    int xL, yT;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HBRUSH hBrush;
	HPEN hPen;

	xL = __intVal(x);
	yT = __intVal(y);
	w = __intVal(width);
	h = __intVal(height);

	DPRINTF(("displayRectangle: %d/%d -> %d/%d\n", 
			xL, yT, w, h));
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	    hPen = gcData->hPen;

	    if (! hPen) {
		hPen = gcData->hPen = CreatePen(gcData->lineStyle,
						gcData->lineWidth,
						gcData->fgColor);
	    }

	    if (! hPen) {
		DPRINTF(("displayRect: no pen\n"));
	    } else {
		MoveToEx(hDC, xL, yT, NULL);
		LineTo(hDC, xL+w-1, yT);
		LineTo(hDC, xL+w-1, yT+h-1);
		LineTo(hDC, xL, yT+h-1);
		LineTo(hDC, xL, yT);
	    }
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

displayString:aString from:index1 to:index2 x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
#   define NLOCALBUFFER 200
    short xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y)) {
	struct gcData *gcData = _GCDATA(aGCId);
	int pX, pY;
	HDC hDC;

	hDC = gcData->hDC;

	pX = __intVal(x);
	pY = __intVal(y);
	pY -= gcData->fontAscent;

	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		RETURN (self);
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;

	    if (__isBytes(aString)) {
		n = __byteArraySize(aString) - nInstBytes - 1;

		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

#ifdef NOTDEF 
	    /* TWOBYTESTRINGS */
	    if (__isWords(aString)) {
		n = (__byteArraySize(aString) - nInstBytes) / 2;

		if (i2 < n) {
		    union {
			char b[2];
			unsigned short s;
		    } u;
		    int i;
		    XChar2b *cp2 = (XChar2b *)0;
		    int mustFree = 0;

		    cp += (i1 * 2);
		    if (l > 1000) l = 1000;

		    /*
		     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
		     * X expects them MSB first
		     * convert as required
		     */

		    u.s = 0x1234;
		    if (u.b[0] != 0x12) {
			if (l <= NLOCALBUFFER) {
			    cp2 = xlatebuffer;
			} else {
			    cp2 = (XChar2b *)(malloc(l * 2));
			    mustFree = 1;
			}
			for (i=0; i<l; i++) {
			    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
			    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			}
			cp = (char *) cp2;
		    }

		    if (opaque == true)
			XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);
		    else
			XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);

		    if (mustFree) {
			free(cp2);
		    }

		    RETURN ( self );
		}
	    }
#endif
	}
    }
#undef NLOCALBUFFER
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

xxxdisplayString:aString x:x y:y in:aDrawableId with:aGCId opaque:opaque 
    "draw a string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
#ifdef NOTDEF
    GC gc;
    Window win;
    unsigned char *cp;
    int n;
    OBJ cls;
#   define NLOCALBUFFER 200
    XChar2b xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(x, y)) {
	gc = _GCVal(aGCId);
	win = _WindowVal(aDrawableId);
	cls = __qClass(aString);

	cp = _stringVal(aString);

	if ((cls == @global(String)) || (cls == @global(Symbol))) {
	    n = _stringSize(aString);
	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	cp += nInstBytes;

	if (__isBytes(aString)) {
	    n = __byteArraySize(aString) - nInstBytes - 1;

	    if (n > 1000) n = 1000;
	    if (opaque == true)
		XDrawImageString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    else
		XDrawString(myDpy, win, gc, __intVal(x), __intVal(y), (char *)cp, n);
	    RETURN ( self );
	}

	/* TWOBYTESTRINGS */
	if (__isWords(aString)) {
	    union {
		char b[2];
		unsigned short s;
	    } u;
	    int i;
	    XChar2b *cp2;
	    int mustFree = 0;

	    n = (__byteArraySize(aString) - nInstBytes) / 2;
	    if (n > 1000) n = 1000;

	    /*
	     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
	     * X expects them MSB first
	     * convert as required
	     */

	    u.s = 0x1234;
	    if (u.b[0] != 0x12) {
		if (n <= NLOCALBUFFER) {
		    cp2 = xlatebuffer;
		} else {
		    cp2 = (XChar2b *)(malloc(n * 2));
		    mustFree = 1;
		}

		for (i=0; i<n; i++) {
		    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
		    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
		}
		cp = (char *) cp2;
	    }

	    if (opaque == true)
		XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);
	    else
		XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, n);


	    if (mustFree) {
		free(cp2);
	    }

	    RETURN ( self );
	}
    }
#undef NLOCALBUFFER
#endif
%}.
    "x/y not integer, badGC or drawable, or not a string"
    self primitiveFailed
!

drawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			  width:imageWidth height:imageHeight 
			      x:srcx y:srcy
			   into:aDrawableId 
			      x:dstx y:dsty 
			  width:w height:h 
			   with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels have bitsPerPixel bits, allowing to draw
     depth and pixel-units to be different.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    "
     sorry; I had to separate it into 2 methods, since XPutImage needs
     an unlimited stack, and thus cannot send primitiveFailed
    "
    (self primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
					width:imageWidth height:imageHeight 
					     x:srcx y:srcy
					  into:aDrawableId 
					     x:dstx y:dsty 
					 width:w height:h 
					  with:aGCId)
    ifFalse:[
	"
	 also happens, if a segmentation violation occurs in the 
	 XPutImage ...
	"
	self primitiveFailed
    ].
!

drawBits:imageBits depth:imageDepth 
		   width:imageWidth height:imageHeight 
		       x:srcx y:srcy
		    into:aDrawableId 
		       x:dstx y:dsty 
		   width:w height:h 
		    with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels must have imageDepth bits.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    ^ self drawBits:imageBits bitsPerPixel:imageDepth depth:imageDepth 
				     width:imageWidth height:imageHeight 
					 x:srcx y:srcy
				      into:aDrawableId 
					 x:dstx y:dsty 
				     width:w height:h 
				      with:aGCId

!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
	       in:aDrawableId with:aGCId
    "fill an arc. If any coordinate is not integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* NOCONTEXT */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = f * 64;
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = f * 64;
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0) && (angle1 >= 0) && (angle2 >= 0)) {
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillPolygon:aPolygon in:aDrawableId with:aGCId
    "fill a polygon given by its points. 
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.
%{
    OBJ point, x, y;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	num = __intVal(numberOfPoints);
	if (num < 3) {
	    RETURN ( self );
	}
	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    x = _point_X(point);
	    y = _point_Y(point);
	    if (! __bothSmallInteger(x, y))
		goto fail;
	}
	RETURN ( self );

fail: ;
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

fillRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "fill a rectangle. If any coordinate is not integer, an error is triggered."

%{  /* NOCONTEXT */

    int w, h;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);

	DDPRINTF(("fillRect %d/%d -> %d/%d\n", __intVal(x), __intVal(y), w, h));

	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	    struct gcData *gcData = _GCDATA(aGCId);
	    HDC hDC;
	    HBRUSH hBrush;
	    RECT rct;

	    hDC = _HDCVal(aGCId);
	    hBrush = gcData->hBrush;

	    if (! hBrush) {
		hBrush = gcData->hBrush = CreateSolidBrush(gcData->fgColor);
	    }

	    if (! hBrush) {
		DPRINTF(("fillRectangle: no brush\n"));
	    } else {
		rct.left = __intVal(x);
		rct.top = __intVal(y);
		rct.right = rct.left + w; /* FillRect excludes right/bottom */
		rct.bottom = rct.top + h;

		FillRect(hDC, &rct, hBrush);
	    }
	}
	RETURN ( self );
    }
%}.
    "badGC, badDrawable or coordinates not integer"
    self primitiveFailed
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth 
			      width:imageWidth height:imageHeight 
				  x:srcx y:srcy
			       into:aDrawableId 
				  x:dstx y:dsty 
			      width:w height:h 
			       with:aGCId

    "since XPutImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */


fail: ;
%}
.
    ^ false
! !

!WinWorkstation methodsFor:'win32 event handling'!

clearX:x y:y width:w height:h view:aView
    "erase part of a view to its background color"

    |oldPaint|

    oldPaint := aView paint.
    aView paint:(aView viewBackground).
    aView fillRectangleX:x y:y width:w height:h.
    aView paint:oldPaint
! !

!WinWorkstation methodsFor:'event handling'!

dispatchEventFor:aViewIdOrNil withMask:eventMask
    "central event handling method:
     get next event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed.
     If the argument aMask is nonNil, only events for this eventMask are
     handled."

    (self getEventFor:aViewIdOrNil withMask:eventMask) ifTrue:[
	AbortSignal catch:[
	    self dispatchLastEvent.
	]
    ].
!

dispatchExposeEventFor:aViewIdOrNil
    "get next expose event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed."

    self dispatchEventFor:aViewIdOrNil withMask:(self eventMaskFor:#expose)
!

dispatchLastEvent
    |theView symS arg butt sibling windowID siblingID propertyID selectionID targetID requestorID
     eventType|

%{  /* STACK: 8000 */
    struct queuedEvent *ev;
    struct inlineCache *ipS;

    static struct inlineCache vid = _ILC1;
    static struct inlineCache confS = _ILC5;
    static struct inlineCache skpS = _ILC4;
    static struct inlineCache skrS = _ILC4;
    static struct inlineCache expS = _ILC5;
    static struct inlineCache clrS = _ILC5;
    static struct inlineCache bpS = _ILC4;
    static struct inlineCache brS = _ILC4;
    static struct inlineCache bmpS = _ILC4;
    static struct inlineCache bspS = _ILC4;
    static struct inlineCache motS = _ILC4;
    static struct inlineCache unmapS = _ILC1;
    static struct inlineCache mapS = _ILC1;
    static struct inlineCache destrS = _ILC1;
    static struct inlineCache focOutS = _ILC1;
    static struct inlineCache focInS = _ILC1;


    int x, y, w, h;
    int keyCode, modifiers, isDoubleClick = 0;
    int isDown = 1;
    int state;
    OBJ upDown;
    char nameBuffer[100];

    DDPRINTF(("dispatchLast\n"));

    ev = deqEvent();
    if (! ev) {
	DPRINTF(("no event in dispatchEvent\n"));
	RETURN (false);
    }

    if (ev->ev_hWnd) {
	windowID = __MKOBJ(ev->ev_hWnd);
	theView = (*vid.ilc_func)(self, @symbol(viewFromId:), nil, &vid, windowID);
    }

    if (theView == nil) {
	DPRINTF(("nil view [hWnd=%x] in dispatchEvent\n", ev->ev_hWnd));

	freeEvent(ev);
	RETURN (false);
    }

    if (ev) {
	switch (ev->ev_message) {
	    case WM_WINDOWPOSCHANGED:
		DPRINTF(("got WM_WINDOWPOSCHANGED -> configureX:y:width:height:view:\n"));

		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;
		freeEvent(ev); ev = NULL;
		(*confS.ilc_func)(self,
			     @symbol(configureX:y:width:height:view:),
			     nil, &confS,
			     __MKSMALLINT(x),
			     __MKSMALLINT(y),
			     __MKSMALLINT(w),
			     __MKSMALLINT(h),
			     theView);
		break;

	    case WM_SHOWWINDOW:
		if (ev->ev_wParam == TRUE) {
		    DPRINTF(("got WM_SHOWWINDOW -> mappedView:\n"));
		    (*mapS.ilc_func)(self,
				     @symbol(mappedView:),
				     nil, &mapS, theView);
		} else {
		    DPRINTF(("got WM_SHOWWINDOW -> unMappedView:\n"));
		    (*unmapS.ilc_func)(self, 
				       @symbol(unmappedView:),
				       nil, &unmapS, theView);
		}
		break;

	    case WM_DESTROY:
		DPRINTF(("got WM_DESTROY -> destroyedView\n"));
		(*destrS.ilc_func)(self,
				   @symbol(destroyedView:),
				   nil, &destrS, theView);
		break;

	    case WM_ACTIVATE:
		DPRINTF(("got WM_ACTIVATE\n"));
		switch (LOWORD(ev->ev_wParam)) {
		    case WA_INACTIVE:
			(*focOutS.ilc_func)(self,
					    @symbol(focusOutView:),
					    nil,
					    &focOutS,
					    theView);
			break;
		    case WA_ACTIVE:
		    case WA_CLICKACTIVE:
			(*focInS.ilc_func)(self,
					   @symbol(focusInView:),
					   nil,
					   &focInS,
					   theView);
			break;
		    default:
			break;
		}
		break;

	    case WM_MOUSEACTIVATE:
		(*focInS.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focInS,
				   theView);
		break;

	    case WM_SETFOCUS:
		(*focInS.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focInS,
				   theView);
		break;

	    case WM_KILLFOCUS:
		(*focOutS.ilc_func)(self,
				   @symbol(focusOutView:),
				   nil,
				   &focOutS,
				   theView);
		break;

	    case WM_ERASEBKGND:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;

		DPRINTF(("WM_ERASEBK -> clear %d/%d -> %d/%d\n", x, y, w, h));
		(*clrS.ilc_func)(self,
			 @symbol(clearX:y:width:height:view:),
			 nil, &clrS,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 theView);
		goto expose;
		break;

	    case WM_PAINT:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;

	    expose:
		DPRINTF(("WM_PAINT -> expose %d/%d -> %d/%d\n", x, y, w, h));
		(*expS.ilc_func)(self,
			 @symbol(exposeX:y:width:height:view:),
			 nil, &expS,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 theView);
		break;

	    case WM_LBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_LBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;
                
	    case WM_LBUTTONDOWN:
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_MBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_MBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;
                
	    case WM_MBUTTONDOWN:
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_RBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    case WM_RBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;
                
	    case WM_RBUTTONDOWN:
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    commonButtonDown:
		x = ev->ev_x;
		y = ev->ev_y;
		modifiers = ev->ev_modifiers;

		if (isDown) {
		    buttonWindow = ev->ev_hWnd;
		} else {
		    buttonWindow = (HWND)0;
		}

		if (__INST(buttonTranslation) != nil) {
		    butt = __AT_(__INST(buttonTranslation), butt);
		}
		arg = butt;

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		freeEvent(ev); ev = NULL;

		if (isDoubleClick) {
		    ipS = &bmpS;
		    symS = @symbol(buttonMultiPress:x:y:view:);
		} else {
		    if (isDown) {
			if (modifiers & ShiftMask) {
			    ipS = &bspS;
			    symS = @symbol(buttonShiftPress:x:y:view:);
			} else {
			    ipS = &bpS;
			    symS = @symbol(buttonPress:x:y:view:);
			}
		    } else {
			ipS = &brS;
			symS = @symbol(buttonRelease:x:y:view:);
		    }
		}

		if (__isSymbol(arg)) {
		    DPRINTF(("buttonPress/buttonRelease: %s %d/%d\n", 
				__stringVal(arg), x, y));
		} else {
		    DPRINTF(("buttonPress/buttonRelease: %d %d/%d\n", 
				__intVal(arg), x, y));
		}

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);
		break;

	    case WM_MOUSEMOVE:
		x = ev->ev_x;
		y = ev->ev_y;
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
		DPRINTF(("buttonMotion: %d/%d\n", x, y));

#ifdef NOTDEF
		if (buttonWindow) {
		    if (buttonWindow != ev->ev_hWnd) {
			/*
			 * translate for window, where button was pressed
			 * originally (X motion semantics)
			 */
			{
			    POINT p;

			    p.x = x;
			    p.y = y;
			    MapWindowPoints(ev->ev_hWnd, buttonWindow, &p, 1);
			    x = p.x;
			    y = p.y;
			    DPRINTF(("xlated to %d/%d for %x\n",
					x, y, buttonWindow));
			}
			windowID = __MKOBJ(buttonWindow);
			theView = (*vid.ilc_func)(self, @symbol(viewFromId:), 
						  nil, &vid, windowID);
		    }
		}
#endif

		(*motS.ilc_func)(self, @symbol(buttonMotion:x:y:view:),
				    nil, &motS,
				    __MKSMALLINT(state),
				    __MKSMALLINT(x),
				    __MKSMALLINT(y),
				    theView);
		break;
                
	    case WM_CHAR:
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skpS;
		upDown = true;
		goto keyPressAndRelease;

	    case WM_SYSKEYUP:
	    case WM_KEYUP:
		symS = @symbol(keyRelease:x:y:view:);
		ipS = &skrS;
		upDown = false;
		goto keyPressAndRelease;

	    case WM_SYSKEYDOWN:
	    case WM_KEYDOWN:
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skpS;
		upDown = true;
		/* FALL INTO */

	    keyPressAndRelease: ;

		x = ev->ev_x;
		y = ev->ev_y;

#ifdef NOTDEF
		{
		    BYTE vKeyState[256];
		    char buff[5];

`                   GetKeyboardState(vKeyState);
		    ToAscii(ev->ev_keyCode, ev->ev_scanCode, vKeyState, &buff; 0);
		}
#endif

		keyCode = ev->ev_keyCode;
		modifiers = ev->ev_modifiers;

		if (modifiers & TRANSLATED_KEY) {
		    if (modifiers & ControlMask) {
			if (keyCode < 0x20) {
			    keyCode = keyCode + 'a' - 1;
			    if (modifiers & ShiftMask) {
				keyCode = keyCode - 'a' + 'A';
			    }
			}
		    } else if (modifiers & (MetaMask | AltMask)) {
			if (! (modifiers & ShiftMask)) {
			    if ((keyCode >= 'A') && (keyCode <= 'Z')) {
				keyCode = keyCode - 'A' + 'a';
			    }
			}
		    }
		    arg = __MKCHARACTER(keyCode & 0xFF);
		} else {
		    switch (keyCode) {
			case '\t':
			    arg = @symbol(Tab);
			    break;

			case '\b':
			    arg = @symbol(BackSpace);
			    break;

			case '\r':
			    arg = @symbol(Return);
			    break;

			case 0x1b:
			    arg = @symbol(Escape);
			    break;

			default:
			    nameBuffer[0] = 0;
			    GetKeyNameText(ev->ev_scanCode, nameBuffer, sizeof(nameBuffer));
			    DPRINTF(("char is <%s>\n", nameBuffer));
			    if (strlen(nameBuffer) == 1) {
				arg = __MKCHARACTER(keyCode & 0xFF);
			    } else {
				arg = __MKSYMBOL(nameBuffer);
			    }
			    break;
		    }
		}

		DPRINTF(("%s: code=%x mod=%x\n", __stringVal(symS),
				keyCode, modifiers));

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		freeEvent(ev); ev = NULL;

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);

		break;

	    default:
		DPRINTF(("unhandled event: %x\n", ev->ev_message));
		break;
	}
    }

    if (ev) {
	freeEvent(ev);
    }
%}.
    ^ true
!

dispatchPendingEvents
    "central event handling method for modal operation.
     (i.e. this is now only used in the modal debugger)
     This code is somewhat special, since X has a concept of graphic
     expose events (which are sent after a bitblt). After such a bitblt,
     we only handle exposes until the graphicsExpose arrives.
     Other systems may not need such a kludge"

    [self eventPendingWithSync:false] whileTrue:[
	self dispatchEventFor:nil withMask:nil
    ]
!

disposeEventsWithMask:aMask for:aWindowIdOrNil
    "dispose (throw away) specific events. If aWindowId is nil,
     events matching the mask are thrown away regardless of which
     view they are for. Otherwise, only matching events for that 
     view are flushed."

%{  /* NOCONTEXT */

%}.
    self primitiveFailed
!

eventMaskFor:anEventSymbol
    "return the eventMask bit-constant corresponding to an event symbol"

%{  /* NOCONTEXT */

    int m = 0;

#ifdef NOTDEF
    if (anEventSymbol == @symbol(keyPress)) m = KeyPressMask;
    else if (anEventSymbol == @symbol(keyRelease)) m = KeyReleaseMask;
    else if (anEventSymbol == @symbol(buttonPress)) m = ButtonPressMask;
    else if (anEventSymbol == @symbol(buttonRelease)) m = ButtonReleaseMask;
    else if (anEventSymbol == @symbol(buttonMotion)) m = ButtonMotionMask;
    else if (anEventSymbol == @symbol(pointerMotion)) m = PointerMotionMask;
    else if (anEventSymbol == @symbol(expose)) m = ExposureMask;
    else if (anEventSymbol == @symbol(focusChange)) m = FocusChangeMask;
    else if (anEventSymbol == @symbol(enter)) m = EnterWindowMask;
    else if (anEventSymbol == @symbol(leave)) m = LeaveWindowMask;
    else if (anEventSymbol == @symbol(keymapState)) m = KeymapStateMask;
    else if (anEventSymbol == @symbol(visibilityChange)) m = VisibilityChangeMask;
    else if (anEventSymbol == @symbol(structureNotify)) m = StructureNotifyMask;
    else if (anEventSymbol == @symbol(resizeRedirect)) m = ResizeRedirectMask;
    else if (anEventSymbol == @symbol(propertyChange)) m = PropertyChangeMask;
    else if (anEventSymbol == @symbol(colormapChange)) m = ColormapChangeMask;
#endif
    RETURN (__MKSMALLINT(m));
%}
!

eventPending
    "return true, if any event is pending. 
     This looks for both the internal queue and the display connection."

    ^ self eventPendingWithSync:false
!

eventPending:anEventSymbol for:aWindowIdOrNil
    "return true, if a specific event is pending"

    ^ self eventsPending:(self eventMaskFor:anEventSymbol) for:aWindowIdOrNil withSync:false
!

eventPendingWithSync:doSync
    "return true, if any event is pending. 
     If doSync is true, do a sync output buffer before checking
     (i.e. send all to the display and wait until its processed)."

%{  /* UNLIMITEDSTACK */

    DDPRINTF(("peek\n"));
    getAllWinEvents();
    if (eventQueueHead) {
	DDPRINTF(("peek - true\n"));
	RETURN (true);
    }
    DDPRINTF(("peek - false\n"));
    RETURN ( false );
%}
!

eventQueued
    "return true, if any event is queued"

    ^ self eventQueuedAlready

    "Created: 12.12.1995 / 21:43:00 / stefan"
!

eventQueuedAlready
    "return true, if any event is queued internally.
     (i.e. in X's internal event queue, which is both filled by explicit
      nextEvent calls AND whenever drawing is done and events are pending on
      the display connection)."

%{  /* NOCONTEXT */

    DDPRINTF(("peek q - "));
    if (eventQueueHead) {
	DDPRINTF(("true\n"));
	RETURN (true);
    }
    DDPRINTF(("false\n"));
    RETURN ( false );
%}
!

eventsPending:anEventMask for:aWindowIdOrNil withSync:doSync
    "return true, if any of the masked events is pending"

%{  /* NOCONTEXT */

    getAllWinEvents();
    DPRINTF(("peek mask %x - false\n", __intVal(anEventMask)));
    
%}.
    ^ false
!

exposeEventPendingFor:aWindowIdOrNil withSync:doSync
    "return true, if any expose event is pending for a specific view,
     or any view (if the arg is nil).
     This is an X specific, only required after a scroll operation."

%{  /* NOCONTEXT */

    getAllWinEvents();
    DPRINTF(("peek view - false\n"));
%}.
    ^ false
!

getEventFor:aViewIdOrNil withMask:eventMask
    "read next event - put into local eventBuffer. 
     If aViewIdOrNil is nil, events for any view are fetched; 
     otherwise only events for that specific view will be fetched.
     Returns true, if there was an event, false otherwise."

%{  /* NOCONTEXT */

    getAllWinEvents();
    if (eventQueueHead) {
	/* no need to copy into buffer */
	DDPRINTF(("get event - true\n"));
	RETURN (true);
    }
    DPRINTF(("get event - false\n"));
%}.
    ^ false
!

handleAllEvents
    "from now on, handle any kind of event"

!

handleExposeOnlyFor:aView
    "from now on, handle expose events only"

!

mappingChanged:what event:eB
    "One of Keyboard-, Modifier- or PointerMap has change, probably by xmodmap.
     Tell xlib about the fact."

    (what == #mappingKeyboard or:[what == #mappingModifier]) ifTrue:[
	self refreshKeyboardMapping:eB.
	"Maybe some of our modifiers have been changed"
	self initializeModifierMappings.
    ].

    "Created: 1.12.1995 / 16:28:23 / stefan"
!

setEventMask:aMask in:aWindowId
    "tell X that we are only interested in events from aMask, which
     is the bitwise or of the eventMask bits (see 'eventMaskFor:')"

    ^ self
! !

!WinWorkstation methodsFor:'event sending'!

sendKeyOrButtonEvent:typeSymbol x:xPos y:yPos keyOrButton:keySymCodeOrButtonNr state:stateMask toViewId:targetId
    "send a keyPress/Release or buttonPress/Release event to some (possibly alien) view.
     TypeSymbol must be one of: #keyPress, #keyRelease, #buttonPress , #buttonRelease.
     For buttonEvents, the keySymCodeOrButtonNr must be the buttons number (1, 2 ...);
     for key events, it can be either a symbol (as listen in X's keySyms)
     or a numeric keysym code. If state is nil, the modifier bits (shift & control)
     are computed from the keyboardMap - if non-nil, these are passed as modifierbits.
     The non-nil case is the lowlevel entry, where state must include any shift/ctrl information
     (not very user friendly)"

    ^ false
!

simulateKeyboardInput:aCharacterOrString inViewId:viewId
    "send input to some other view, by simulating keyPress/keyRelease
     events. 
     Only a few control characters are supported.
     Notice: not all alien views allow this kind of synthetic input;
	     some simply ignore it."

    |control code state|

    aCharacterOrString isString ifTrue:[
	aCharacterOrString do:[:char |
	    self simulateKeyboardInput:char inViewId:viewId
	].
	^ self
    ].

    control := false.
    code := aCharacterOrString asciiValue.

    (aCharacterOrString == Character cr) ifTrue:[
	code := #Return
    ] ifFalse:[
	(aCharacterOrString == Character tab) ifTrue:[
	    code := #Tab 
	] ifFalse:[
	    (aCharacterOrString == Character esc) ifTrue:[
		code := #Escape 
	    ]
	]
    ].

    control ifTrue:[
	state := self controlMask
    ].


    "/ the stuff below should not be needed 
    "/ (sendKeyOrButtonevent should be able to figure out things itself)
    "/ however, on some linux systems it seems to not work correctly.
    "/ Hopefully, this is correct ...

    code isNumber ifTrue:[
	code >= $A asciiValue ifTrue:[
	    code <= $Z asciiValue ifTrue:[
		state := self shiftMask
	    ]
	]
    ].

    self sendKeyOrButtonEvent:#keyPress x:0 y:0 keyOrButton:code state:state toViewId:viewId.
    self sendKeyOrButtonEvent:#keyRelease x:0 y:0 keyOrButton:code state:state toViewId:viewId

    "
      sending input to some (possibly alien) view:

      |point id|

      point :=  Display pointFromUser.
      id := Display viewIdFromPoint:point.
      Display simulateKeyboardInput:'Hello_world' inViewId:id
    "

    "Modified: 11.6.1996 / 10:59:42 / cg"
! !

!WinWorkstation methodsFor:'font stuff'!

createFontFor:aFontName
    "a basic method for font allocation; this method allows
     any font to be aquired (even those not conforming to
     standard naming conventions, such as cursor, fixed or k14)"

%{
    HGDIOBJ hFont;
    char *fn;

    if (__isString(aFontName)) {
	fn = __stringVal(aFontName);
	if (strcmp(fn, "fixed") == 0) {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	} else if (strcmp(fn, "variable") == 0) {
	    hFont = GetStockObject(ANSI_VAR_FONT);
	} else {
	    hFont = (HGDIOBJ)0;
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	}
	if (hFont) {
	    DPRINTF(("createFont: %s -> %x\n", fn, hFont));
	    RETURN ( __MKOBJ(hFont) );
	}
    }
%}.
    ^ nil
!

fontMetricsOf:fontId into:aBlock
    "evaluate aBlock, passing a fonts metrics as arguments"

    |encoding avgAscent avgDescent
     maxAscent maxDescent minWidth maxWidth avgWidth|

%{
    HGDIOBJ hFont;
    HGDIOBJ prevFont;
    HDC rootDC;
    TEXTMETRIC tmet;
    int len;

    if (ISCONNECTED) {
	if (__isExternalAddress(fontId)) {
	    hFont = _HGDIOBJVal(fontId);
	    /*
	     * temporarily set this font in the root context
	     */
	    rootDC = __rootDC;
	    prevFont = SelectObject(rootDC, hFont);
	    GetTextMetrics(rootDC, &tmet);
	    SelectObject(rootDC, prevFont);

	    avgAscent = __MKSMALLINT(tmet.tmAscent);
	    avgDescent = __MKSMALLINT(tmet.tmDescent);
	    maxAscent = __MKSMALLINT(tmet.tmAscent);
	    maxDescent = __MKSMALLINT(tmet.tmDescent);
	    minWidth = __MKSMALLINT(tmet.tmAveCharWidth);
	    maxWidth = __MKSMALLINT(tmet.tmMaxCharWidth);
	    avgWidth = __MKSMALLINT(tmet.tmAveCharWidth);
	    DPRINTF(("textMetrics h=%x  avgAsc=%d avgDesc=%d minW=%d maxW=%d avgW=%d\n",
			hFont, tmet.tmAscent, tmet.tmDescent, tmet.tmAveCharWidth, tmet.tmMaxCharWidth,
			tmet.tmAveCharWidth));
	}
    }
%}.
    encoding := #iso8859.
    aBlock value:encoding
	   value:avgAscent
	   value:avgDescent
	   value:maxAscent
	   value:maxDescent
	   value:minWidth
	   value:maxWidth
	   value:avgWidth
!

fullNameOf:aFontId
    "the fonts fullName - this is very device specific and should only be
     used for user feed-back (for example: in the fontPanel).
     If the display/font do not provide that info, return nil."

    ^ nil
!

getAvailableFontsMatching:pattern
    "return an Array filled with font names matching aPattern"

    ^ nil
!

getDefaultFont
    "return a default font id - used when class Font cannot
     find anything usable"

     ^ self createFontFor:'fixed'
!

getFontWithFamily:familyString face:faceString
	    style:styleArgString size:sizeArg encoding:encodingSym

    "try to get the specified font, if not available, try next smaller
     font. Access to X-fonts by name is possible, by passing the X font name
     as family and the other parameters as nil. For example, the cursor font
     can be aquired that way."

    |styleString theName theId xlatedStyle id spacing|

    styleString := styleArgString.

    "special: if face is nil, allow access to X-fonts"
    faceString isNil ifTrue:[
	sizeArg notNil ifTrue:[
	    theName := familyString , '-' , sizeArg printString
	] ifFalse:[
	    theName := familyString
	].
	theName isNil ifTrue:[
	    "
	     mhmh - fall back to the default font
	    "
	    theName := 'fixed'
	].
	theId := self createFontFor:theName.
	theId isNil ifTrue:[
	    theId := self getDefaultFont
	].
	^ theId
    ].

    "/ spacing other than 'normal' is contained as last component
    "/ in style

    ((styleString endsWith:'-narrow') 
     or:[styleString endsWith:'-semicondensed']) ifTrue:[
	|i|
	i := styleString lastIndexOf:$-.
	spacing := styleString copyFrom:(i+1).
	styleString := styleString copyTo:(i-1).
    ] ifFalse:[
	spacing := 'normal'.
    ].

    xlatedStyle := styleString.
    xlatedStyle notNil ifTrue:[
	xlatedStyle := xlatedStyle first asString
    ].

    id := self 
	    getFontWithFoundry:'*'
	    family:familyString asLowercase
	    weight:faceString
	    slant:xlatedStyle
	    spacing:spacing
	    pixelSize:nil
	    size:sizeArg 
	    registry:encodingSym
	    encoding:'*'.

    id isNil ifTrue:[
	(encodingSym notNil and:[encodingSym ~= '*']) ifTrue:[
	    "/ too stupid: encodings come in both cases
	    "/ and X does not ignore case
	    "/
	    id := self 
		    getFontWithFoundry:'*'
		    family:familyString asLowercase
		    weight:faceString
		    slant:xlatedStyle
		    spacing:spacing
		    pixelSize:nil
		    size:sizeArg 
		    registry:encodingSym asUppercase
		    encoding:'*'.
	    id isNil ifTrue:[
		id := self 
			getFontWithFoundry:'*'
			family:familyString asLowercase
			weight:faceString
			slant:xlatedStyle
			spacing:spacing
			pixelSize:nil
			size:sizeArg 
			registry:encodingSym asLowercase
			encoding:'*'.
	    ]
	]
    ].
    ^ id

    "Modified: 24.2.1996 / 22:37:24 / cg"
    "Modified: 4.7.1996 / 11:38:47 / stefan"
!

getFontWithFoundry:foundry family:family weight:weight
	      slant:slant spacing:spc pixelSize:pSize size:size 
	      registry:registry encoding:encoding

    "get the specified font, if not available, return nil.
     This is the new font creation method - all others will be changed to
     use this entry.
     Individual attributes can be left empty (i.e. '') or nil to match any.

     foundry: 'adobe', 'misc', 'dec', 'schumacher' ... usually '*'
     family:  'helvetica' 'courier' 'times' ...
     weight:  'bold' 'medium' 'demi' ...
     slant:   'r(oman)' 'i(talic)' 'o(blique)'
     spacing: 'narrow' 'normal' semicondensed' ... usually '*'
     pixelSize: 16,18 ... usually left empty
     size:      size in point (1/72th of an inch)
     registry:  iso8859, sgi ... '*'
     encoding:  vendor specific encoding (usually '*')
    "

    |theName sizeMatch 
     foundryMatch familyMatch weightMatch slantMatch spcMatch
     pSizeMatch registryMatch encodingMatch
     id|

    "this works only on 'Release >= 3' - X-servers"
    "name is:
	-foundry-family    -weight -slant-
	 sony    helvetica bold     r
	 adobe   courier   medium   i
	 msic    fixed              o
	 ...     ...
    "

    size isNil ifTrue:[
	sizeMatch := '*'
    ] ifFalse:[
	sizeMatch := size printString , '0'
    ].
    foundry isNil ifTrue:[
	foundryMatch := '*'
    ] ifFalse:[
	foundryMatch := foundry
    ].
    family isNil ifTrue:[
	familyMatch := '*'
    ] ifFalse:[
	familyMatch := family
    ].
    weight isNil ifTrue:[
	weightMatch := '*'
    ] ifFalse:[
	weightMatch := weight
    ].
    slant isNil ifTrue:[
	slantMatch := '*'
    ] ifFalse:[
	slantMatch := slant
    ].
    spc isNil ifTrue:[
	spcMatch := '*'
    ] ifFalse:[
	spcMatch := spc
    ].
    pSize isNil ifTrue:[
	pSizeMatch := '*'
    ] ifFalse:[
	pSizeMatch := pSize printString
    ].
    registry isNil ifTrue:[
	registryMatch := '*'
    ] ifFalse:[
	registryMatch := registry
    ].
    encoding isNil ifTrue:[
	encodingMatch := '*'
    ] ifFalse:[
	encodingMatch := encoding
    ].

    theName := ('-' , foundryMatch,
		'-' , familyMatch,
		'-' , weightMatch ,
		'-' , slantMatch , 
		'-' , spcMatch ,
		'-*' ,
		'-' , pSizeMatch ,
		'-' , sizeMatch ,
		'-*-*-*-*' ,
		'-' , registryMatch ,
		'-' , encodingMatch).

"/  Transcript showCR:theName; endEntry.

    ^ self createFontFor:theName.

    "
     Display getFontWithFoundry:'*'
			 family:'courier'
			 weight:'medium'
			  slant:'r'
			spacing:nil
		      pixelSize:nil
			   size:13
		       registry:'iso8859'
		       encoding:'*'
    "

    "Modified: 24.2.1996 / 22:33:29 / cg"
!

listOfAvailableFonts
    "return a list with all available fonts on this display.
     Since this takes a long time, keep the result of the query for the
     next time. The elements of the returned collection are instances of
     FontDescription."

    ^ listOfFonts

    "
     Display listOfAvailableFonts.

     Display getAvailableFontsMatching:'*'.
    "

    "Modified: 27.9.1995 / 10:54:47 / stefan"
    "Modified: 17.4.1996 / 15:27:57 / cg"
!

releaseFont:aFontId

    ^ self
!

sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font sizes in aFamily/aFace/aStyle
     on this display.
     Redefined to handle X's special case of 0-size (which stands for any)"

    |sizes|

    sizes := super sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter.
    (sizes notNil and:[sizes includes:0]) ifTrue:[
	"special: in X11R5 and above, size 0 means:
	 there are scaled versions in all sizes available"

	^ #(4 5 6 7 8 9 10 11 12 14 16 18 20 22 24 28 32 48 64)
    ].
    ^ sizes

    "
     Display sizesInFamily:'courier' face:'bold' style:'roman'
    "

    "Created: 27.2.1996 / 01:38:15 / cg"
!

widthOf:aString from:index1 to:index2 inFont:aFontId

%{  /* NOCONTEXT */
    char *cp;
    int len, n, i1, i2, l;
    OBJ cls;
    int nInstBytes;

    if (ISCONNECTED) {
	if (__bothSmallInteger(index1, index2)
	 && __isExternalAddress(aFontId)
	 && __isNonNilObject(aString)) {
	    HDC rootDC;
	    HGDIOBJ hFont;
	    SIZE tsize;

	    rootDC = __rootDC;
	    hFont = _HGDIOBJVal(aFontId);

	    i1 = __intVal(index1) - 1;
	    cls = __qClass(aString);

	    if (i1 >= 0) {
		i2 = __intVal(index2) - 1;
		if (i2 < i1) {
		    RETURN (self);
		}

		cp = (char *) _stringVal(aString);
		l = i2 - i1 + 1;

		if ((cls == @global(String)) || (cls == @global(Symbol))) {
		    n = _stringSize(aString);
		    if (i2 < n) {
			cp += i1;

			SelectObject(rootDC, hFont);
			GetTextExtentPoint(rootDC, cp, l, &tsize);
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}

		nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
		cp += nInstBytes;

		if (__isBytes(aString)) {
		    n = __byteArraySize(aString) - nInstBytes;
		    if (i2 < n) {
			cp += i1;

			SelectObject(rootDC, hFont);
			GetTextExtentPoint(rootDC, cp, l, &tsize);
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}

#ifdef NOTDEF
		/* TWOBYTESTRINGS */
		if (__isWords(aString)) {
		    n = (__byteArraySize(aString) - nInstBytes) / 2;

		    if (i2 < n) {
			union {
			    char b[2];
			    unsigned short s;
			} u;
			int i;
			XChar2b *cp2 = (XChar2b *)0;
			int mustFree = 0;

			cp += (i1 * 2);
			if (l > 1000) l = 1000;

			/*
			 * ST/X TwoByteStrings store the asciiValue in native byteOrder;
			 * X expects them MSB first
			 * convert as required
			 */

			u.s = 0x1234;
			if (u.b[0] != 0x12) {
			    if (l <= NLOCALBUFFER) {
				cp2 = xlatebuffer;
			    } else {
				cp2 = (XChar2b *)(malloc(l * 2));
				mustFree = 1;
			    }
			    for (i=0; i<l; i++) {
				cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
				cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			    }
			    cp = (char *) cp2;
			}
			BEGIN_INTERRUPTSBLOCKED
			len = XTextWidth16(f, (XChar2b *)cp, l);
			END_INTERRUPTSBLOCKED

			if (mustFree) {
			    free(cp2);
			}

			RETURN ( __MKSMALLINT(len) );
		    }
		}
#endif
	    }
	}
    }
#undef NLOCALBUFFER
%}.
    self primitiveFailed.
    ^ nil
! !

!WinWorkstation methodsFor:'grabbing '!

allowEvents:mode
!

grabKeyboardIn:aWindowId
    "grab the keyboard"

!

grabPointerIn:aWindowId withCursor:aCursorId pointerMode:pMode keyboardMode:kMode confineTo:confineId
    "grap the pointer - return true if ok"
%{
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	SetCapture(hWnd);
    }
%}.
    activePointerGrab := aWindowId.
    ^ true
!

ungrabKeyboard
    "release the keyboard"

    activeKeyboardGrab := nil
!

ungrabPointer
    "release the pointer"

%{
    ReleaseCapture();
%}.
    activePointerGrab := nil
! !

!WinWorkstation methodsFor:'graphic context stuff'!

noClipIn:aGCId
    "disable clipping rectangle"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setBackground:bgColorIndex in:aGCId
    "set background color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF bgColor;

	hDC = _HDCVal(aGCId);
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DPRINTF(("setBackground: %x\n", bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setBitmapMask:aBitmapId in:aGCId
    "set or clear the drawing mask - a bitmap mask using current fg/bg"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setClipByChildren:aBool in:aGCId
    "enable/disable drawing into child views"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:aGCId
    "clip to a rectangle"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setDashes:dashList dashOffset:offset in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setFont:aFontId in:aGCId
    "set font to be drawn in"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aFontId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HGDIOBJ hFont;
	TEXTMETRIC tmet;

	hDC = gcData->hDC;
	hFont = _HGDIOBJVal(aFontId);

	SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tmet);
	gcData->fontAscent = tmet.tmAscent;
	DPRINTF(("setFont: %x\n", hFont));
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex in:aGCId
    "set foreground and background colors to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = gcData->hDC;
	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil)"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId lineWidth:lw in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil); also set lineWidth"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	if (__intVal(lw) != gcData->lineWidth) {
	    if (gcData->hPen) {
		DeleteObject(gcData->hPen);
		gcData->hPen = (HPEN)0;
	    }
	    gcData->lineWidth = __intVal(lw);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setForeground:fgColorIndex in:aGCId
    "set foreground color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->hBrush) {
		DeleteObject(gcData->hBrush);
		gcData->hBrush = (HBRUSH)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	DDPRINTF(("setForeground: %x\n", fgColor));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setFunction:aFunctionSymbol in:aGCId
    "set alu function to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;
    int fun;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	if (aFunctionSymbol == @symbol(copy)) fun = R2_COPYPEN;
	else if (aFunctionSymbol == @symbol(copyInverted)) fun = R2_NOTCOPYPEN;
	else if (aFunctionSymbol == @symbol(xor)) fun = R2_XORPEN;
	else if (aFunctionSymbol == @symbol(and)) fun = R2_MASKPEN;
	else if (aFunctionSymbol == @symbol(andReverse)) fun = R2_MASKPENNOT;
	else if (aFunctionSymbol == @symbol(andInverted)) fun = R2_NOTMASKPEN;
	else if (aFunctionSymbol == @symbol(or)) fun = R2_MERGEPEN;
	else if (aFunctionSymbol == @symbol(orReverse)) fun = R2_MERGEPENNOT;
	else if (aFunctionSymbol == @symbol(orInverted)) fun = R2_NOTMERGEPEN;
	if (fun != -1) {
	    SetROP2(hDC, fun);
	}
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setGraphicsExposures:aBoolean in:aGCId
    "set or clear the graphics exposures flag"

!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)
     && __isSmallInteger(aNumber)) {
	struct gcData *gcData = _GCDATA(aGCId);
	hDC = _HDCVal(aGCId);

	if (gcData->hPen) {
	    DeleteObject(gcData->hPen);
	    gcData->hPen = (HBRUSH)0;
	}

	gcData->lineWidth = __intVal(aNumber);
	if (lineStyle == @symbol(solid)) {
	    gcData->lineStyle = PS_SOLID;
	} else if (lineStyle == @symbol(dashed)) {
	    gcData->lineStyle = PS_DASH;
	} else
	    gcData->lineStyle = PS_DASH;

	if (capStyle == @symbol(round)) {
	    gcData->capStyle = PS_ENDCAP_ROUND;
	} else if (capStyle == @symbol(square)) {
	    gcData->capStyle = PS_ENDCAP_SQUARE;
	} else if (capStyle == @symbol(flat)) {
	    gcData->capStyle = PS_ENDCAP_FLAT;
	} else
	    gcData->capStyle = PS_ENDCAP_FLAT;

	if (joinStyle == @symbol(bevel)) {
	    gcData->joinStyle = PS_JOIN_BEVEL;
	} else if (joinStyle == @symbol(miter)) {
	    gcData->joinStyle = PS_JOIN_MITER;
	} else if (joinStyle == @symbol(round)) {
	    gcData->joinStyle = PS_JOIN_ROUND;
	} else
	    gcData->joinStyle = PS_JOIN_MITER;

	RETURN (self);
    }
%}.
    self primitiveFailed
!

setMaskOriginX:orgX y:orgY in:aGCId
    "set the mask origin"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
!

setPixmapMask:aPixmapId in:aGCId
    "set or clear the drawing mask - a pixmap mask providing full color"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	RETURN (self);
    }
%}.
    self primitiveFailed
! !

!WinWorkstation methodsFor:'initialize / release'!

close
    "close down the connection to the X-server"

!

initializeDefaultValues
    buttonTranslation := ButtonTranslation.
    multiClickTimeDelta := MultiClickTimeDelta.

    self initializeModifierMappings
!

initializeEventBuffer
!

initializeFor:aDisplayName
    "initialize the receiver for a connection to an X-Server;
     the argument, aDisplayName may be nil (for the default server from
     DISPLAY-variable or command line argument) or the name of the server 
     as hostname:number"

%{
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int rgbVisualID;
    int nvi, i;
    int shapeEventBase, shapeErrorBase;
    int shmEventBase, shmErrorBase;
    int faxEventBase, faxErrorBase;
    char *type, *nm;
    int dummy;
    OBJ dpyID;

    if (__INST(displayId) != nil) {
	/*
	 * already connected - you bad guy try to
	 * trick me manually ?
	 */
	RETURN ( self );
    }

    __INST(displayId) = __MKSMALLINT(1);

%}.

    dispatching := false.
    isSlow := false.
    shiftDown := false.
    ctrlDown := false.
    metaDown := false.
    altDown := false.
    motionEventCompression := true.
    buttonsPressed := 0.

    self initializeScreenProperties.

    self initializeDefaultValues.
    self initializeEventBuffer.
    self initializeSpecialFlags.
    self initializeKeyboardMap.
!

initializeModifierMappings
    shiftModifiers := #(#'Shift_L' #'Shift_R' #'Shift').
    ctrlModifiers := #(#'Ctrl_L' #'Ctrl_R' #'Ctrl').
    metaModifiers := #(#'Alt_L' #'Alt').
    altModifiers := #(#'Alt_R').
!

initializeScreenProperties
    super initializeScreenProperties.

%{  /* NOCONTEXT */

    int scr;
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int nvi, i, val, capabilities, __depth;
    char *type, *nm;
    int dummy;
    int mask, shift, nBits;
    HWND _rootWin = NULL;
    RECT rect;
    HDC _rootDC;
    OBJ id;

    _rootWin = GetDesktopWindow();
    __INST(rootWin) = id = __MKOBJ(_rootWin); __STORE(self, id);

    _rootDC = CreateDC("DISPLAY", NULL, NULL, NULL);
    __INST(rootDC) = id = __MKOBJ(_rootDC); __STORE(self, id);

    GetWindowRect(_rootWin, &rect);
    __INST(width) = __MKSMALLINT(rect.right-rect.left);
    __INST(height) = __MKSMALLINT(rect.bottom-rect.top);
    printf("screen is %d/%d\n", __intVal(__INST(width)), __intVal(__INST(height)));

    __depth = GetDeviceCaps(_rootDC, BITSPIXEL);

    __INST(depth) = __MKSMALLINT(__depth);
    __INST(ncells) = __MKSMALLINT(1<<__depth);

    val = GetDeviceCaps(_rootDC, HORZSIZE);
    __INST(widthMM) = __MKSMALLINT(val);
    val = GetDeviceCaps(_rootDC, VERTSIZE);
    __INST(heightMM) = __MKSMALLINT(val);


    capabilities = GetDeviceCaps(_rootDC, RASTERCAPS);

    __INST(whitepixel) = __MKSMALLINT(RGB(0xFF, 0xFF, 0xFF));
    __INST(blackpixel) = __MKSMALLINT(RGB(0,0,0));

    if (! (capabilities & RC_PALETTE)) {
	DPRINTF(("no palette\n"));
	if (__depth == 1) {
	    __INST(visualType) = @symbol(GrayScale);
	    __INST(hasColors) = false;
	    __INST(hasGreyscales) = false;
	    __INST(monitorType) = @symbol(monochrome);
	} else {
	    __INST(visualType) = @symbol(StaticColor);
	    __INST(hasColors) = true;
	    __INST(hasGreyscales) = true;
	}
    } else {
	val = GetDeviceCaps(_rootDC, SIZEPALETTE); /* First two entries are black and white. */

	__INST(ncells) = __MKSMALLINT(val);
	__INST(blackpixel) = __MKSMALLINT(0);
	__INST(whitepixel) = __MKSMALLINT(1);
	__INST(hasColors) = true;
	__INST(hasGreyscales) = true;
    }      

    __INST(monitorType) = @symbol(unknown);

    __INST(redShift) = __MKSMALLINT(0);
    __INST(greenShift) = __MKSMALLINT(8);
    __INST(blueShift) = __MKSMALLINT(16);
    __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(8);

    __INST(resizeFrameWidth) = GetSystemMetrics(SM_CXSCREEN) - GetSystemMetrics(SM_CXFULLSCREEN);
    __INST(resizeFrameHeight) = GetSystemMetrics(SM_CYSCREEN) - GetSystemMetrics(SM_CYFULLSCREEN);
DPRINTF(("fW=%d fH=%d\n",
	    __intVal(__INST(resizeFrameWidth)),
	    __intVal(__INST(resizeFrameHeight)) ));
%}.
!

initializeSpecialFlags
    "perform additional special server implementation flags"
!

reinitialize
    rootWin := rootDC := nil.
    super reinitialize.
! !

!WinWorkstation methodsFor:'keyboard mapping'!

altModifierMask
    "return the mask (in motionEvents) for the alt-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(AltMask));
%}

    "Created: 23.3.1996 / 12:43:22 / cg"
    "Modified: 23.3.1996 / 12:44:56 / cg"
!

metaModifierMask
    "return the mask (in motionEvents) for the meta-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(MetaMask));
%}

    "Created: 23.3.1996 / 12:43:39 / cg"
    "Modified: 23.3.1996 / 12:45:09 / cg"
!

leftAltMask
    "return the mask bit for the left Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(LeftAltMask));
%}
!

rightAltMask
    "return the mask bit for the right Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(RightAltMask));
%}
!

modifierMapping
    "Get the Modifier Mapping.
     We return an array of arrays of keycodes"

    ^ nil
!

stringFromKeycode:code
    "Get a KeySymbol (a smalltalk symbol) from the keycode."

    ^ ''

    "
	Display stringFromKeycode:28
    "
!

translateKey:untranslatedKey
    |key|

    (key := untranslatedKey) isCharacter ifFalse:[
	key := RawKeysymTranslation at:key ifAbsent:key.
	key := key asSymbol.
'xlated: ' print. untranslatedKey print. ' to: ' print. key printCR.
    ].
    ^ super translateKey:key
! !

!WinWorkstation methodsFor:'misc'!

beep
    "output an audible beep or bell"

    self beep:50
!

beep:volumeInPercent
    "output an audible beep"
%{
    Beep(__intVal(@global(BeepFrequency)), __intVal(@global(BeepDuration)));
%}
!

refreshKeyboardMapping:eB
!

setInputFocusTo:aWindowId
    self setInputFocusTo:aWindowId revertTo:nil
!

setInputFocusTo:aWindowId revertTo:revertSymbol
    "set the focus to the view as defined by aWindowId.
     Passing nil set the focus to no window and lets the display discard all
     input until a new focus is set.
     RevertSymbol specifies what should happen if the view becomes invisible;
     passing one of #parent, #root or nil specifies that the focus should be
     given to the parent view, the root view or no view."

%{
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetFocus(hWnd);
	}
	RETURN ( self );
    }
%}
! !

!WinWorkstation methodsFor:'pointer queries '!

anyButtonStateMask
    "return an integer for masking out any button from a
     buttonStates value."

    "/ should use ``Display buttonXMotionMask bitOr:....''

    ^ 256 + 512 + 1024

    "Modified: 23.3.1996 / 12:41:33 / cg"
    "Created: 23.3.1996 / 12:46:35 / cg"
!

buttonStates
    "return an integer representing the state of the pointer buttons;
     a one-bit in positions 0.. represent a pressed button.
     See the button1Mask/button2Mask/button3Mask,
     shiftMask/controlMask and modifierMask methods for the meaning of the bits."

    ^ 0


    "
     Display buttonStates     
    "

    "is the control-key pressed ?

     Display buttonStates bitTest:(Display controlMask)    
    "

    "is the alt/meta-key pressed ?

     Display buttonStates bitTest:(Display altModifierMask)    
     Display buttonStates bitTest:(Display metaModifierMask)    
    "
!

leftButtonStateMask
    "return an integer for masking out the left button from a
     buttonStates value"

    "/ should use ``Display button1MotionMask''

    ^ 256

    "Modified: 23.3.1996 / 12:41:33 / cg"
!

middleButtonStateMask
    "return an integer for masking out the middle button from a
     buttonStates value"

    "/ should use ``Display button2MotionMask''

    ^ 512

    "Modified: 23.3.1996 / 12:41:43 / cg"
!

pointerPosition
    "return the current pointer position in root-window coordinates"

    |xpos ypos|

%{
    POINT p;

    if (GetCursorPos(&p)) {
	xpos = __MKSMALLINT(p.x);
	ypos = __MKSMALLINT(p.y);
    } else {
	xpos = ypos = __MKSMALLINT(0);
    }
%}.
    ^ xpos @ ypos
!

rightButtonStateMask
    "return an integer for masking out the right button from a
     buttonStates value"

    "/ should use ``Display button3MotionMask''

    ^ 1024

    "Modified: 23.3.1996 / 12:41:52 / cg"
!

rootPositionOfLastEvent
    "return the position in root-window coordinates
     of the last button, key or pointer event"

    |x y|

%{
    x = __MKSMALLINT(evRootX);
    y = __MKSMALLINT(evRootY);
%}.
    ^ x @ y
! !

!WinWorkstation methodsFor:'retrieving pixels'!

getBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getPixelX:x y:y from:aDrawableId
    "return the pixel value at x/y; coordinates start at 0/0 for the upper left.
     Nil is returned for invalid coordinates or if any other problem arises."

    ^ nil
!

primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space 
     (some implementations use alloca), this must run with unlimited stack."

    ^ false
! !

!WinWorkstation methodsFor:'window stuff'!

clearRectangleX:x y:y width:width height:height in:aWindowId
    "clear a rectangular area to viewbackground"
%{
    DPRINTF(("clearRect\n"));
%}.
    super clearRectangleX:x y:y width:width height:height in:aWindowId
!

clearWindow:aWindowId
    "clear a window to viewbackground"

%{
    DPRINTF(("clearWin\n"));
%}.
    super clearWindow:aWindowId
!

configureWindow:aWindowId sibling:siblingId stackMode:modeSymbol
    "configure stacking operation of aWindowId w.r.t siblingId"

!

lowerWindow:aWindowId
    "bring a window to back"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);

	    BringWindowToTop(win);
	}
	RETURN ( self );
    }
%}.

!

mapView:aView id:aWindowId iconified:aBoolean atX:xPos y:yPos width:w height:h
    "make a window visible - either as icon or as a real view - needed for restart"

!

mapWindow:aWindowId
    "make a window visible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_SHOW);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

moveResizeWindow:aWindowId x:x y:y width:w height:h
    "move and resize a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(w, h)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, (HWND)0, 
			 __intVal(x), __intVal(y),
			 __intVal(w), __intVal(h),
			 SWP_NOACTIVATE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

moveWindow:aWindowId x:x y:y
    "move a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    SetWindowPos(win, (HWND)0,
			 __intVal(x), __intVal(y),
			 0, 0,
			 SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

raiseWindow:aWindowId
    "bring a window to front"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetWindowPos(hWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

resizeWindow:aWindowId width:w height:h
    "resize a window"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(w, h)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetWindowPos(hWnd, (HWND)0, 
			 0, 0, 
			 __intVal(w), __intVal(h), 
			 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

setBackingStore:how in:aWindowId
    "turn on/off backing-store for a window"

!

setBitGravity:how in:aWindowId
    "set bit gravity for a window"

!

setCursor:aCursorId in:aWindowId
    "define a windows cursor"

!

setIconName:aString in:aWindowId
    "define a windows iconname"

!

setSaveUnder:yesOrNo in:aWindowId
    "turn on/off save-under for a window"

!

setTransient:aWindowId for:aMainWindowId
    "set aWindowId to be a transient of aMainWindow"

!

setWindowBackground:aColorIndex in:aWindowId
    "set the windows background color. This is the color with which
     the view is filled whenever exposed. Do not confuse this with
     the background drawing color, which is used with opaque drawing."

!

setWindowBackgroundPixmap:aPixmapId in:aWindowId
    "set the windows background pattern to be a form.
     This is the pattern with which the view is filled whenever exposed. 
     Do not confuse this with the background drawing color, which is used 
     with opaque drawing."

!

setWindowBorderColor:aColorIndex in:aWindowId
    "set the windows border color"

!

setWindowBorderPixmap:aPixmapId in:aWindowId
    "set the windows border pattern"

!

setWindowBorderWidth:aNumber in:aWindowId
    "set the windows border width"

!

setWindowClass:wClass name:wName in:aWindowId
    "define class and name of a window.
     This may be used by the window manager to
     select client specific resources."

!

setWindowGravity:how in:aWindowId
    "set window gravity for a window"

!

setWindowIcon:aForm in:aWindowId
    "define a bitmap to be used as icon"

!

setWindowIcon:aForm mask:aMaskForm in:aWindowId
    "define a windows icon & iconMask"

!

setWindowIconWindow:aView in:aWindowId
    "define a window to be used as icon"

!

setWindowName:aString in:aWindowId
    "define a windows name"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
	HWND win = _HWNDVal(aWindowId);

	SetWindowText(win, __stringVal(aString));
	RETURN (self);
    }
%}.
    self primitiveFailed
!

unmapWindow:aWindowId
    "make a window invisible"

%{  /* NOCONTEXT */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_HIDE);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed
! !

!WinWorkstation  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/WinWorkstation.st,v 1.18 1997-02-25 16:52:46 cg Exp $'
! !

WinWorkstation initialize!
